"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.appendPrepend = appendPrepend;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _AppendPrepend = _interopRequireDefault(require("../package/input/AppendPrepend"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 *创建appendPrepend
 */
function appendPrepend() {
  return function (Component) {
    var RenderComponent = Component;

    var ForwardedComponent = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
      var prepend = props.prepend,
          append = props.append;

      if (prepend !== undefined || append !== undefined) {
        return /*#__PURE__*/_react.default.createElement(_AppendPrepend.default, _objectSpread(_objectSpread({}, props), {}, {
          component: Component,
          ref: ref
        }), props.children);
      } else {
        return /*#__PURE__*/_react.default.createElement(RenderComponent, _objectSpread(_objectSpread({}, props), {}, {
          ref: ref
        }), props.children);
      }
    });

    ForwardedComponent.displayName = RenderComponent.name || RenderComponent.displayName || "AppendPrepend";
    var HS = (0, _hoistNonReactStatics.default)(ForwardedComponent, RenderComponent);
    return HS;
  };
}