/// <reference types="node" />
import React, { Component } from 'react';
interface Props {
    isShow: boolean;
    children?: React.ReactNode;
}
export default class CollapseTransition extends Component<Props> {
    cssWrapper: HTMLElement;
    leaveTimer: NodeJS.Timeout;
    enterTimer: NodeJS.Timeout;
    oldOverflow: string;
    /** */
    componentDidMount(): void;
    /** */
    componentWillUnMount(): void;
    /** */
    componentDidUpdate(prevProps: Props): void;
    /** */
    triggerChange(isShow: boolean): void;
    /** */
    beforeEnter(): void;
    /** */
    enter(): void;
    /** */
    afterEnter(): void;
    /** */
    beforeLeave(): void;
    /** */
    leave(): void;
    /** */
    afterLeave(): void;
    /** */
    render(): React.ReactNode;
}
export {};
