"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _CascadeList = _interopRequireDefault(require("./CascadeList"));

var _CascadeContext = require("./CascadeContext");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CascadePanel = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(CascadePanel, _React$Component);

  var _super = _createSuper(CascadePanel);

  function CascadePanel() {
    var _this;

    (0, _classCallCheck2.default)(this, CascadePanel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      options: [],
      value: []
    };
    return _this;
  }

  (0, _createClass2.default)(CascadePanel, [{
    key: "handleChange",
    value:
    /***
     *
     * @param option
     * @param index
     * @param e
     * @param expandTrigger
     */
    function handleChange(option, index, e, expandTrigger) {
      var _this$props = this.props,
          onChange = _this$props.onChange,
          onChooseEnd = _this$props.onChooseEnd;
      var value = this.state.value;

      var _value = (0, _toConsumableArray2.default)(value);

      _value = _value.slice(0, index);
      _value[index] = option.value === undefined ? option.label : option.value;

      if (expandTrigger === 'click') {
        onChange && onChange(_value, e);
        onChooseEnd && onChooseEnd();
      }
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          options = _this$props2.options,
          onChange = _this$props2.onChange,
          expandTrigger = _this$props2.expandTrigger,
          changeOnSelect = _this$props2.changeOnSelect,
          useCustomScrollBar = _this$props2.useCustomScrollBar,
          size = _this$props2.size,
          onLoadData = _this$props2.onLoadData;
      var _this$state = this.state,
          dataOptions = _this$state.options,
          value = _this$state.value;
      var classes = (0, _classnames.default)(className, 'rd-cascade-dropdown', "rd-cascade-dropdown--".concat(size));
      var dataSource = [(0, _toConsumableArray2.default)(options)].concat((0, _toConsumableArray2.default)(dataOptions));
      return /*#__PURE__*/React.createElement(_CascadeContext.CascadeContext.Provider, {
        value: {
          options: options,
          value: value,
          useCustomScrollBar: useCustomScrollBar,
          onLoadData: onLoadData,
          expandTrigger: expandTrigger,
          onChange: this.handleChange,
          set: function set(data, index, e, trigger) {
            var options = _this2.state.options;

            var _options = (0, _toConsumableArray2.default)(options);

            var _value = (0, _toConsumableArray2.default)(value);

            _options = _options.slice(0, index);
            _value = _value.slice(0, index);
            _options[index] = data.children || [];
            _value[index] = data.value === undefined ? data.label : data.value;

            if (trigger === 'click' && changeOnSelect) {
              onChange && onChange(_value, e);
            }

            _this2.setState({
              value: _value,
              options: _options
            });
          }
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style)
      }, dataSource.map(function (item, index) {
        if (!item.length) {
          return;
        }

        return /*#__PURE__*/React.createElement(_CascadeList.default, {
          key: JSON.stringify(item),
          index: index,
          options: item
        });
      })));
    }
  }], [{
    key: "getStateOptionsByValue",
    value:
    /**
     *
     * @param value
     * @param options
     */
    function getStateOptionsByValue(value, options) {
      var _options = [];
      /**当前树的层级**/

      var level = 0;

      if (value.length !== 0) {
        var loop = function loop(options) {
          var currentValue = value[level];

          for (var i = 0; i < options.length; i++) {
            var item = options[i];

            var _value = item.value === undefined ? item.label : item.value;

            if (currentValue === _value) {
              /**将同级的都取出**/
              _options[level] = (0, _toConsumableArray2.default)(options);

              if (item.children) {
                level = level + 1;
                loop(item.children);
              }
            }
          }
        };

        loop(options);
      }

      return _options.slice(1, _options.length);
    }
    /**
     *
     * @param nextProps
     * @param prevState
     */

  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (prevState._prevProps !== undefined && nextProps.value !== prevState.value) {
        /**判断nextProps与之前存的props的值是否有改变**/
        if (prevState._prevProps !== nextProps) {
          var options;

          if (nextProps.value.length !== 0) {
            options = CascadePanel.getStateOptionsByValue(nextProps.value, nextProps.options);
          } else {
            options = prevState.options;
          }
          /**将本次nextProps的值存在state中去**/


          return {
            _prevProps: nextProps,
            options: options,
            value: nextProps.value
          };
        } else {
          /**将本次nextProps的值存在state中去**/
          return {
            _prevProps: nextProps,
            value: prevState.value
          };
        }
      }

      if (prevState._prevProps === undefined) {
        return {
          options: CascadePanel.getStateOptionsByValue(nextProps.value, nextProps.options),
          _prevProps: nextProps,
          value: nextProps.value
        };
      }

      return null;
    }
  }]);
  return CascadePanel;
}(React.Component), _class2.defaultProps = {
  options: [],
  expandTrigger: 'hover',
  useCustomScrollBar: false
}, _class2)) || _class;

exports.default = CascadePanel;