"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _CheckboxContext = _interopRequireDefault(require("./CheckboxContext"));

var _Checkbox2 = _interopRequireDefault(require("./Checkbox"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _excluded = ["disabled", "value", "size", "style", "label", "children", "name", "className"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var CheckboxButton = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_Checkbox) {
  (0, _inherits2.default)(CheckboxButton, _Checkbox);

  var _super = _createSuper(CheckboxButton);

  function CheckboxButton() {
    var _this;

    (0, _classCallCheck2.default)(this, CheckboxButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(CheckboxButton, [{
    key: "size",
    value:
    /**
      * 获取父级尺寸
      */
    function size() {
      var parent = this.parent();
      var newSize = this.props.size;

      if (parent) {
        newSize = parent.props.size;
      }

      return newSize;
    }
    /**
     * 获取填充颜色
     */

  }, {
    key: "activeStyle",
    value: function activeStyle() {
      var parent = this.parent();
      var _this$props = this.props,
          fill = _this$props.fill,
          textColor = _this$props.textColor,
          style = _this$props.style;
      return _objectSpread({
        backgroundColor: parent ? parent.props.fill : fill,
        borderColor: parent ? parent.props.fill : fill,
        color: parent ? parent.props.textColor : textColor,
        boxShadow: parent ? '-1px 0 0 0 ' + parent.props.fill : 'none'
      }, style);
    }
    /**
         * button渲染
         */

  }, {
    key: "buttonRender",
    value: function buttonRender() {
      var _this2 = this;

      var checked = this.state.checked;
      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          value = _this$props2.value,
          size = _this$props2.size,
          style = _this$props2.style,
          label = _this$props2.label,
          children = _this$props2.children,
          name = _this$props2.name,
          className = _this$props2.className,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var otherProps = (0, _omit.default)(rest, ['fill', 'textColor', 'options', 'indeterminate']);
      var newValue = value;

      if (value === undefined) {
        newValue = label;
      }

      var labelText = children || label;
      return /*#__PURE__*/React.createElement("label", {
        style: checked ? this.activeStyle() : _objectSpread({}, style),
        className: (0, _classnames.default)(className, 'rd-checkbox-button', this.size() && 'rd-checkbox-button--' + this.size(), {
          'is-active': checked,
          'is-disabled': disabled,
          'is-checked': checked
        })
      }, /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, otherProps, {
        type: "checkbox",
        className: "rd-checkbox-button__original",
        checked: checked === undefined ? false : checked,
        disabled: disabled,
        value: value,
        onChange: function onChange(e) {
          return _this2.handleChange(newValue, e);
        }
      })), labelText && /*#__PURE__*/React.createElement("span", {
        className: "rd-checkbox-button__inner"
      }, labelText));
    }
    /**
         * 渲染
         */

  }, {
    key: "render",
    value: function render() {
      /**注意：radio和checkbox的button单独使用时需要添加一个标签将button包裹一下样式才会正常显示 */
      return this.buttonRender();
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
     * 更新
     * @param nextProps
     * @param prevState
     */
    function getDerivedStateFromProps(nextProps, prevState) {
      return _Checkbox2.default.getDerivedStateFromProps(nextProps, prevState);
    }
  }]);
  return CheckboxButton;
}(_Checkbox2.default), _class2.contextType = _CheckboxContext.default, _class2.defaultProps = {
  size: 'medium',
  checked: false
}, _class2)) || _class;

exports.default = CheckboxButton;