"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _ = _interopRequireDefault(require("."));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var WeekPositionTypes = (0, _types.tuple)('inner', 'outer');
var WeekTypes = (0, _types.tuple)('default', 'button');
var CheckboxWeek = (_dec = (0, _FormElement.createFormElement)(true), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(CheckboxWeek, _React$Component);

  var _super = _createSuper(CheckboxWeek);

  /**
   *
   * @param props
   */
  function CheckboxWeek(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CheckboxWeek);
    _this = _super.call(this, props);
    _this.state = {
      optionArr: [],
      checkArr: []
    };
    return _this;
  }
  /**
   * 判断是否为半选状态
   * @param nextProps
   * @param prevState
   */


  (0, _createClass2.default)(CheckboxWeek, [{
    key: "handleChange",
    value:
    /**
     * 周一到周天点击改变事件
     */
    function handleChange(value) {
      this.setState({
        checkArr: value
      });
      var onChange = this.props.onChange;
      onChange && onChange(value);
    }
    /**
     * 全选
     */

  }, {
    key: "handleClickAll",
    value: function handleClickAll(value, e) {
      var _this$state = this.state,
          optionArr = _this$state.optionArr,
          checkArr = _this$state.checkArr;
      var checkedAllArr = checkArr;

      if (e.target.checked) {
        optionArr.map(function (item) {
          checkedAllArr = Array.from(new Set([].concat((0, _toConsumableArray2.default)(checkedAllArr), [item.value !== undefined ? item.value : item.label])));
        });
      } else {
        optionArr.map(function (option) {
          checkArr.map(function (item, index) {
            if (item === (option.value !== undefined ? option.value : option.label)) {
              checkedAllArr.splice(index, 1);
            }
          });
        });
        checkedAllArr = checkArr;
      }

      this.setState({
        checkArr: checkedAllArr
      });
      var onChange = this.props.onChange;
      onChange && onChange(checkedAllArr);
    }
    /**
     * 判断显示checkbox类型
     */

  }, {
    key: "checkboxRender",
    value: function checkboxRender() {
      var _this$state2 = this.state,
          checkArr = _this$state2.checkArr,
          indeterminate = _this$state2.indeterminate,
          checkedAll = _this$state2.checkedAll;
      var props = (0, _extends2.default)({}, this.props);

      if (props.type === 'button') {
        return /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)(props.className, 'rd-checkbox-week')
        }, /*#__PURE__*/React.createElement(_.default.Button, (0, _extends2.default)({}, props.indeterminateOption, {
          className: (0, _classnames.default)(props.indeterminateClassName, 'rd-checkbox-week__all'),
          checked: checkedAll,
          indeterminate: indeterminate,
          onChange: this.handleClickAll
        })), /*#__PURE__*/React.createElement(_.default.Group, {
          className: (0, _classnames.default)(props.itemClassName, "rd-checkbox-week--".concat(props.position)),
          value: checkArr,
          onChange: this.handleChange
        }, props.options.map(function (item, index) {
          return /*#__PURE__*/React.createElement(_.default.Button, (0, _extends2.default)({
            key: index
          }, item));
        })));
      } else {
        return /*#__PURE__*/React.createElement("div", {
          className: (0, _classnames.default)(props.className, 'rd-checkbox-week')
        }, /*#__PURE__*/React.createElement(_.default, (0, _extends2.default)({}, props.indeterminateOption, {
          className: (0, _classnames.default)(props.indeterminateClassName, 'rd-checkbox-week__all'),
          checked: checkedAll,
          indeterminate: indeterminate,
          onChange: this.handleClickAll
        })), /*#__PURE__*/React.createElement(_.default.Group, {
          className: (0, _classnames.default)(props.itemClassName, "rd-checkbox-week--".concat(props.position)),
          value: checkArr,
          onChange: this.handleChange
        }, props.options.map(function (item, index) {
          return /*#__PURE__*/React.createElement(_.default, (0, _extends2.default)({
            key: index
          }, item));
        })));
      }
    }
    /**
     *渲染
     */

  }, {
    key: "render",
    value: function render() {
      var props = (0, _extends2.default)({}, this.props);
      return /*#__PURE__*/React.createElement(React.Fragment, null, props.type === 'button' ? this.checkboxRender() : this.checkboxRender());
    }
  }], [{
    key: "getIndeterminate",
    value: function getIndeterminate(optionArr, checkArr) {
      var optionsChecked = [];
      (optionArr || []).map(function (item) {
        var value = item.value !== undefined ? item.value : item.label;

        if (checkArr.includes(value)) {
          optionsChecked.push(value);
        }
      }); //选中的不能为空且总长度不能为可选总长度

      return {
        indeterminate: optionsChecked.length !== 0 && optionsChecked.length !== optionArr.length,
        checkedAll: optionsChecked.length === optionArr.length
      };
    }
    /**
     * 更新父级
     * @param nextProps
     * @param prevState
     */

  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newIndeterminate = nextProps.indeterminate;
      var newCheckedAll = nextProps.checkedAll;
      var newCheckArr = nextProps.value;
      var newOptionArr = nextProps.options.filter(function (item) {
        return !item.disabled;
      });
      var newDisabledLength = nextProps.options.filter(function (item) {
        return item.disabled;
      }).length;

      if (prevState._prevProps) {
        if (nextProps.value === prevState._prevProps.value) {
          newCheckArr = prevState.checkArr;
        }

        var _CheckboxWeek$getInde = CheckboxWeek.getIndeterminate(newOptionArr, newCheckArr),
            indeterminate = _CheckboxWeek$getInde.indeterminate,
            checkedAll = _CheckboxWeek$getInde.checkedAll;

        if (nextProps.checkedAll === prevState._prevProps.checkedAll) {
          newCheckedAll = checkedAll;
        }

        if (nextProps.indeterminate === prevState._prevProps.indeterminate) {
          newIndeterminate = indeterminate;
        }
      } else {
        var _CheckboxWeek$getInde2 = CheckboxWeek.getIndeterminate(newOptionArr, newCheckArr),
            _indeterminate = _CheckboxWeek$getInde2.indeterminate,
            _checkedAll = _CheckboxWeek$getInde2.checkedAll;

        if (nextProps.indeterminate === undefined) {
          newIndeterminate = _indeterminate;
        }

        if (nextProps.checkedAll === undefined) {
          newCheckedAll = _checkedAll;
        }
      }

      return {
        _prevProps: nextProps,
        indeterminate: newIndeterminate,
        optionArr: newOptionArr || [],
        checkedAll: newCheckedAll,
        checkArr: newCheckArr || [],
        disabledLength: newDisabledLength
      };
    }
  }]);
  return CheckboxWeek;
}(React.Component), _class2.defaultProps = {
  type: 'default',
  position: 'outer'
}, _class2)) || _class) || _class);
exports.default = CheckboxWeek;