import * as React from 'react';
import { D, DatePickerProps, S } from '../Types';
declare type Props = DatePickerProps<D, S> & {
    date?: Date;
    onPicked: (value: number) => void;
    disabledDate: (date: D) => boolean;
};
declare type State = {};
export default class MonthTable extends React.Component<Props, State> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props: Props);
    /**
     * 单元格样式
     * @param month
     */
    getCellStyle(month: number): React.CSSProperties;
    /**
     * 单元格点击
     * @param event
     */
    handleMonthTableClick(event: any): void;
    /**
     * 月表格渲染
     */
    render(): React.ReactNode;
}
export {};
