/**
 * 年面板
 */
import React from 'react';
import { TimePickerProps, D, S } from '../Types';
declare type Props = TimePickerProps<D, S> & {
    date?: Date;
    onPicked: (value: number) => void;
    disabledDate: (date: D) => boolean;
};
export default class YearTable extends React.Component<Props> {
    /**
     * 单元格样式
     * 添加是否(禁用，当前选中，今天)样式
     * @param year
     */
    getCellStyle(year: number): any;
    /**
      * 单元格点击，如果a标签上存在disabled样式，则不能点击
      * @param event
      */
    handleYearTableClick(event: React.MouseEvent): void;
    /**
     * 年表格渲染
     */
    render(): React.ReactNode;
}
export {};
