import * as React from 'react';
import { ObjectType } from "../../libs/types";
export interface DropdownItemProps {
    disabled?: boolean;
    divided?: boolean;
    children?: React.ReactNode;
    className?: string;
    style?: React.CSSProperties;
    /**附件的额外数据**/
    data?: ObjectType;
    onClick?: (event: React.MouseEvent) => void;
}
export default class DropdownItem extends React.Component<DropdownItemProps> {
    static defaultProps: {};
    private readonly key;
    static contextType: React.Context<any>;
    /**
     * 构造函数
     * @param props
     * @param context
     */
    constructor(props: DropdownItemProps, context: {
        set: (params: {
            key: string;
            option: DropdownItemProps;
        }) => void;
    });
    /**
     * 更新后
     */
    componentDidUpdate(): void;
    /**
     * 将要卸载
     */
    componentWillUnmount(): void;
    /**
     * 渲染函数
     */
    render(): React.ReactElement;
}
