import * as React from 'react';
interface DropdownMenuProps {
    children?: React.ReactNode;
    className?: string;
    style?: React.CSSProperties;
    useCustomScrollBar?: boolean;
    listHeight?: number;
    itemHeight?: number;
    customOption?: any[];
    customOptionTemp?: (customOption: any[], item: any, index: number) => React.ReactNode;
}
interface DropdownMenuState {
    maxHeight?: string;
    maxWidth?: string;
}
export default class DropdownMenu extends React.Component<DropdownMenuProps, DropdownMenuState> {
    static defaultProps: {
        useCustomScrollBar: boolean;
    };
    static contextType: React.Context<any>;
    private el;
    private keysOption;
    state: DropdownMenuState;
    /**获取css属性高度 */
    componentDidMount(): void;
    /**
     * 代理item点击
     * @param e
     */
    handleClick(e: React.MouseEvent): void;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export {};
