"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _classnames = _interopRequireDefault(require("classnames"));

var _DropdownContext = _interopRequireWildcard(require("./DropdownContext"));

var _ScrollBar = _interopRequireDefault(require("../scroll-bar/ScrollBar"));

var _rcVirtualList = _interopRequireDefault(require("rc-virtual-list"));

var _select = _interopRequireDefault(require("../select"));

var _excluded = ["maxHeight", "maxWidth"];

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DropdownMenu = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(DropdownMenu, _React$Component);

  var _super = _createSuper(DropdownMenu);

  function DropdownMenu() {
    var _this;

    (0, _classCallCheck2.default)(this, DropdownMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.el = /*#__PURE__*/React.createRef();
    _this.keysOption = {};
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(DropdownMenu, [{
    key: "componentDidMount",
    value:
    /**获取css属性高度 */
    function componentDidMount() {
      var useCustomScrollBar = this.props.useCustomScrollBar;

      if (useCustomScrollBar && this.el.current) {
        var computedStyle = getComputedStyle(this.el.current);
        this.setState({
          maxHeight: computedStyle.maxHeight,
          maxWidth: computedStyle.maxWidth
        });
      }
    }
    /**
     * 代理item点击
     * @param e
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var target = e.target;
      var role = target.getAttribute('role');

      if (target === this.el.current) {
        return;
      }
      /**找到target**/


      while (!(role === 'dropdown-menu-item' && !!target._UUID)) {
        target = target.parentNode;
        role = target.getAttribute('role');

        if (target === this.el.current) {
          return;
        }
      }
      /**有disabled 标识就不继续**/


      if (target._disabled) {
        return;
      }

      var key = target._UUID;
      var childOption = this.keysOption[key];

      var _ref = this.context || {},
          onItemClick = _ref.onItemClick;

      e.persist();
      onItemClick && onItemClick(e, childOption);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          _this$props$style = _this$props.style,
          style = _this$props$style === void 0 ? {} : _this$props$style,
          className = _this$props.className,
          useCustomScrollBar = _this$props.useCustomScrollBar,
          listHeight = _this$props.listHeight,
          itemHeight = _this$props.itemHeight,
          customOption = _this$props.customOption,
          customOptionTemp = _this$props.customOptionTemp;
      var classes = (0, _classnames.default)('rd-dropdown-menu', className);
      var maxHeight = style.maxHeight,
          maxWidth = style.maxWidth,
          restStyle = (0, _objectWithoutProperties2.default)(style, _excluded);
      var _this$state = this.state,
          cssMaxHeight = _this$state.maxHeight,
          cssMaxWidth = _this$state.maxWidth;
      var finalMaxHeight = maxHeight || cssMaxHeight || 'auto';
      var finalMaxWidth = maxWidth || cssMaxWidth || 'auto';
      return /*#__PURE__*/React.createElement(_DropdownContext.DropdownMenuContext.Provider, {
        value: {
          set: function set(params) {
            _this2.keysOption[params.key] = params.option;
          },
          remove: function remove(key) {
            delete _this2.keysOption[key];
          }
        }
      }, /*#__PURE__*/React.createElement(_DropdownContext.default.Consumer, null, function (_ref2) {
        var renderFake = _ref2.renderFake;

        if (renderFake) {
          return children;
        } else {
          return useCustomScrollBar ? /*#__PURE__*/React.createElement("div", {
            role: "dropdown-menu",
            ref: _this2.el,
            style: _objectSpread({}, restStyle),
            className: classes,
            onClick: _this2.handleClick
          }, customOption ? /*#__PURE__*/React.createElement(_rcVirtualList.default, {
            data: customOption,
            height: listHeight,
            itemHeight: itemHeight,
            itemKey: "value"
          }, function (item, index) {
            if (customOptionTemp) {
              return customOptionTemp(customOption, item, index);
            } else {
              var label = item.label,
                  value = item.value;
              return /*#__PURE__*/React.createElement(_select.default.Option, {
                key: value,
                value: value
              }, label);
            }
          }) : /*#__PURE__*/React.createElement(_ScrollBar.default, {
            autoHeight: true,
            autoHeightMax: finalMaxHeight,
            style: {
              maxHeight: finalMaxHeight,
              maxWidth: finalMaxWidth
            }
          }, children)) : /*#__PURE__*/React.createElement("div", {
            role: "dropdown-menu",
            ref: _this2.el,
            style: _objectSpread({}, style),
            className: classes,
            onClick: _this2.handleClick
          }, children);
        }
      }));
    }
  }]);
  return DropdownMenu;
}(React.Component), _class2.defaultProps = {
  useCustomScrollBar: false
}, _class2.contextType = _DropdownContext.default, _class2)) || _class;

exports.default = DropdownMenu;