import * as React from 'react';
interface DynamicFormListProps {
    defaultFields?: Array<{
        key?: string;
        index: number;
    }>;
    children?: (value: {
        fields?: Array<{
            key: string;
            index: number;
        }>;
        add?: () => void;
        remove?: () => void;
    }) => React.ReactNode;
}
interface DynamicFormListStates {
    UUID?: number;
    dynamicFields?: Array<{
        key: string;
        index: number;
    }>;
}
export default class DynamicFormList extends React.Component<DynamicFormListProps, DynamicFormListStates> {
    static defaultProps: {
        defaultFields: {
            key: string;
            index: number;
        }[];
    };
    /**
     * 构造函数
     * @param props
     */
    constructor(props: DynamicFormListProps);
    /**
     * 新增
     * @param defaultValue
     * @param insertIndex
     */
    private _add;
    /**
     * 移除
     * @param index
     */
    private _remove;
    /**
     *
     */
    render(): React.ReactElement;
}
export {};
