"use strict";

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SizeContext = exports.FormItemContext = exports.FormContext = exports.DynamicFormContext = void 0;

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _FormContext = /*#__PURE__*/React.createContext(undefined);

_FormContext.displayName = 'FormContext';
var FormContext = _FormContext;
exports.FormContext = FormContext;

var _DynamicFormContext = /*#__PURE__*/React.createContext(undefined);

_DynamicFormContext.displayName = 'DynamicFormContext';
var DynamicFormContext = _DynamicFormContext;
exports.DynamicFormContext = DynamicFormContext;

var _FormItemContext = /*#__PURE__*/React.createContext(undefined);

_FormItemContext.displayName = 'FormItemContext';
var FormItemContext = _FormItemContext;
/**表单元素的尺寸大小**/

exports.FormItemContext = FormItemContext;

var _SizeContext = /*#__PURE__*/React.createContext(undefined);

_SizeContext.displayName = 'SizeContext';
var SizeContext = _SizeContext;
exports.SizeContext = SizeContext;