import * as React from 'react';
declare type ColSpanType = number | string;
export interface ColSize {
    span?: ColSpanType;
    offset?: ColSpanType;
}
export interface ColProps extends React.HTMLAttributes<HTMLDivElement> {
    span?: ColSpanType;
    offset?: ColSpanType;
    prefixCls?: string;
    xs?: ColSpanType | ColSize;
    sm?: ColSpanType | ColSize;
    md?: ColSpanType | ColSize;
    lg?: ColSpanType | ColSize;
    xl?: ColSpanType | ColSize;
}
export default class Col extends React.Component<ColProps> {
    validSpan: (span: number | string) => number | string;
    renderCol: () => React.ReactNode;
    /** */
    render(): React.ReactNode;
}
export {};
