"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _types = require("../../libs/types");

var _transition = _interopRequireDefault(require("../transition"));

var _RadioSelect = _interopRequireDefault(require("net-design-icons/lib/icons/RadioSelect"));

var _InformationFill = _interopRequireDefault(require("net-design-icons/lib/icons/InformationFill"));

var _ReminderPlane = _interopRequireDefault(require("net-design-icons/lib/icons/ReminderPlane"));

var _ClosePlane = _interopRequireDefault(require("net-design-icons/lib/icons/ClosePlane"));

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _util = require("../../libs/utils/util");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var assets = {
  default: /*#__PURE__*/React.createElement(_RadioSelect.default, {
    className: "rd-info__icon"
  }),
  error: /*#__PURE__*/React.createElement(_ClosePlane.default, {
    className: "rd-info__icon"
  }),
  info: /*#__PURE__*/React.createElement(_InformationFill.default, {
    className: "rd-info__icon"
  }),
  success: /*#__PURE__*/React.createElement(_RadioSelect.default, {
    className: "rd-info__icon"
  }),
  warning: /*#__PURE__*/React.createElement(_ReminderPlane.default, {
    className: "rd-info__icon"
  })
};
var PlacementTypes = (0, _types.tuple)('top', 'top-left', 'top-right', 'bottom', 'bottom-left', 'bottom-right');
var InfoTypes = (0, _types.tuple)('default', 'success', 'warning', 'info', 'error');

var isTop = function isTop(placement) {
  return placement.indexOf('top') > -1;
};

var Toast = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Toast, _React$Component);

  var _super = _createSuper(Toast);

  /**定时器**/

  /**唯一标识**/

  /**组件是否卸载**/

  /**动画是否结束**/

  /**
   * 构造函数
   * @param props
   */
  function Toast(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Toast);
    _this = _super.call(this, props);
    _this.timer = void 0;
    _this.id = void 0;
    _this._isMounted = false;
    _this._transitionFinished = false;
    _this.ref = void 0;
    _this.height = 0;
    _this.id = (0, _util.UUID)();
    _this.state = {
      visible: false
    };
    return _this;
  }
  /**
   *
   * @param nextProps
   * @param prevState
   */


  (0, _createClass2.default)(Toast, [{
    key: "safeSetState",
    value:
    /**
     * 安全的设置State
     */
    function safeSetState(state, callback) {
      if (this._isMounted) {
        this.setState(state, callback);
      }
    }
    /**
     * 组件第一次加载
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this._isMounted = true; //设置当前内容高度

      if (this.ref) {
        this.height = this.ref.clientHeight;
        var _this$props = this.props,
            getIntanceHeight = _this$props.getIntanceHeight,
            _placement = _this$props.placement,
            interval = _this$props.interval;
        getIntanceHeight && getIntanceHeight(this.height + interval, _placement);
      }

      this.safeSetState({
        visible: true
      });
    }
    /**
     * 组件卸载
     */

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._isMounted = false;
    }
    /**
     * 处理鼠标离开
     */

  }, {
    key: "handleMouseLeave",
    value: function handleMouseLeave() {
      var duration = this.state.duration;

      if (duration === 0) {
        return;
      }

      this.forceClear();
    }
    /**
     * 关闭
     */

  }, {
    key: "forceClear",
    value: function forceClear() {
      var _this2 = this;

      var duration = this.state.duration;
      clearTimeout(this.timer);
      this.timer = setTimeout(function () {
        _this2.safeSetState({
          visible: false
        });
      }, duration);
    }
    /**
     * 处理鼠标进入
     */

  }, {
    key: "handleMouseEnter",
    value: function handleMouseEnter() {
      clearTimeout(this.timer);
    }
    /**
     * 处理关闭
     */

  }, {
    key: "handleClose",
    value: function handleClose() {
      this.safeSetState({
        visible: false
      });
    }
    /**
     * 更新状态 供外部调用用于单例
     * @param options
     */

  }, {
    key: "updateView",
    value: function updateView(options) {
      var _this3 = this;

      /**如果动画结束后 那么应该清楚之前的定时器**/
      if (this._transitionFinished) {
        clearTimeout(this.timer);
      }

      this.safeSetState({
        top: options.top,
        bottom: options.bottom,
        type: options.type,
        content: options.content,
        visible: true,
        duration: typeof options.duration === 'undefined' ? this.props.duration : options.duration //options.duration可能为0

      }, function () {
        /**由于更新state不会触发Transition的onAfterEnter 所以需要判断一下动画是否结束 如果没有结束那么就应该手动触发一下**/
        if (_this3._transitionFinished) {
          _this3.handleMouseLeave();
        }
      });
      return {
        destroy: this.props.destroy
      };
    }
    /**
     * 处理动画离开
     */

  }, {
    key: "handleTransitionLeave",
    value: function handleTransitionLeave() {
      //如果消失之前，单例，visible刚好又变为了true，此时不消失
      var visible = this.state.visible;

      if (visible) {
        return;
      }

      var destroy = this.props.destroy;
      destroy.apply(this, []);
    }
    /**
     *动画开始结束后
     */

  }, {
    key: "handleTransitionAfterEnter",
    value: function handleTransitionAfterEnter() {
      this._transitionFinished = true;
      this.handleMouseLeave();
    }
    /**
     * 更新状态 供外部调用
     * @param options
     */

  }, {
    key: "updateTop",
    value: function updateTop(options) {
      this.safeSetState({
        top: options.top,
        bottom: options.bottom
      });
    }
    /**生成Icon图标 */

  }, {
    key: "renderCloseIcon",
    value: function renderCloseIcon() {
      var closeIcon = this.props.closeIcon;

      if (closeIcon) {
        return /*#__PURE__*/React.cloneElement(closeIcon, _objectSpread(_objectSpread({}, closeIcon.props), {}, {
          onClick: this.handleClose
        }));
      } else {
        return /*#__PURE__*/React.createElement(_Close.default, {
          className: "rd-info__icon-close",
          onClick: this.handleClose
        });
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          visible = _this$state.visible,
          top = _this$state.top,
          bottom = _this$state.bottom,
          type = _this$state.type,
          content = _this$state.content;
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          showClose = _this$props2.showClose,
          placement = _this$props2.placement,
          transitionName = _this$props2.transitionName,
          showIcon = _this$props2.showIcon;
      var classes = (0, _classnames.default)(className, 'rd-info', "rd-info--".concat(type), showClose && 'is-closable', "is-".concat(placement));

      var _content = content != null && (0, _typeof2.default)(content) === 'object' && !content.props && !content.type ? "".concat(JSON.stringify(content)) : content;

      var placementStyle = {};
      isTop(placement) ? placementStyle.top = top : placementStyle.bottom = bottom;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_transition.default, {
        name: transitionName,
        onAfterEnter: this.handleTransitionAfterEnter,
        onAfterLeave: this.handleTransitionLeave
      }, visible && /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread(_objectSpread({}, style), placementStyle),
        onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave
      }, showIcon && assets[type], /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-info__content')
      }, /*#__PURE__*/React.createElement("span", {
        className: "content-content"
      }, _content), showClose && this.renderCloseIcon()))), !visible && /*#__PURE__*/React.createElement("div", {
        ref: function ref(_ref) {
          return _this4.ref = _ref;
        },
        className: classes,
        style: _objectSpread(_objectSpread({}, style), {}, {
          opacity: 0,
          zIndex: -1
        })
      }, showIcon && assets[type], /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-info__content')
      }, /*#__PURE__*/React.createElement("span", {
        className: "content-content"
      }, _content), showClose && this.renderCloseIcon())));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      return _objectSpread(_objectSpread({}, nextProps), prevState);
    }
  }]);
  return Toast;
}(React.Component), _class2.defaultProps = {
  top: 20,
  type: 'default',
  duration: 3000,
  showClose: false,
  singleton: false,
  transitionName: 'rd-info-fade',
  placement: 'top',
  interval: 20,
  showIcon: true
}, _class2)) || _class;

var Info = function () {
  var instance; //let index = 0;

  var active = []; //let activeId: number;
  //下一次距离顶部，或者距离底部的距离

  var infoByPlacement = {
    'top': {
      singletonId: -1,
      distance: 0
    },
    'bottom': {
      singletonId: -1,
      distance: 0
    },
    'top-left': {
      singletonId: -1,
      distance: 0
    },
    'bottom-left': {
      singletonId: -1,
      distance: 0
    },
    'top-right': {
      singletonId: -1,
      distance: 0
    },
    'bottom-right': {
      singletonId: -1,
      distance: 0
    }
  };

  var handleInstanceHeight = function handleInstanceHeight(height, placement) {
    infoByPlacement[placement].distance += height;
  };

  var Singleton = /*#__PURE__*/(0, _createClass2.default)(
  /**
   * 构造函数
   * @param options
   */
  function Singleton(options) {
    (0, _classCallCheck2.default)(this, Singleton);
    this.destroy = void 0;
    var messageRoot = document.createElement('div');
    messageRoot.setAttribute('role', 'info');
    document.body.appendChild(messageRoot);
    var _options$defaultTop = options.defaultTop,
        defaultTop = _options$defaultTop === void 0 ? 20 : _options$defaultTop,
        _options$defaultBotto = options.defaultBottom,
        defaultBottom = _options$defaultBotto === void 0 ? 20 : _options$defaultBotto,
        _options$placement = options.placement,
        placement = _options$placement === void 0 ? 'top' : _options$placement,
        _options$interval = options.interval,
        interval = _options$interval === void 0 ? 20 : _options$interval;

    if (isTop(placement)) {
      if (infoByPlacement[placement].distance === 0) {
        infoByPlacement[placement].distance = defaultTop;
      }

      options.top = infoByPlacement[placement].distance;
    } else {
      //bottom
      if (infoByPlacement[placement].distance === 0) {
        infoByPlacement[placement].distance = defaultBottom;
      }

      options.bottom = infoByPlacement[placement].distance;
    }

    var instanceOptions = _objectSpread(_objectSpread({}, options), {}, {
      destroy: function destroy() {
        var _this5 = this;

        var destroyIndex = active.findIndex(function (item) {
          return item.id === _this5.id;
        });
        var _active$destroyIndex = active[destroyIndex],
            destroyHeight = _active$destroyIndex.height,
            props = _active$destroyIndex.props;
        var placement = props.placement;
        (0, _reactDom.unmountComponentAtNode)(messageRoot); // 若messageRoot不在document.body里面时，使用removeChild会报错
        // 比如：在info弹窗还没消失的时候切换语言：海康AC6项目

        if (document.body.contains(messageRoot)) {
          document.body.removeChild(messageRoot);
        }

        active.forEach(function (item, index) {
          if (index > destroyIndex) {
            var state = item.state; //相同类型的才处理，不同 类型的不处理

            if (placement === item.props.placement) {
              if (isTop(placement)) {
                var top = state.top - destroyHeight - interval;
                item.updateTop({
                  top: top
                });
              } else {
                var bottom = state.bottom - destroyHeight - interval;
                item.updateTop({
                  bottom: bottom
                });
              }
            }
          }
        });
        /**如果当前激活的id是本实例 那么本实例销毁后activeId也应该销毁**/

        if (infoByPlacement[placement].singletonId === this.id) {
          infoByPlacement[placement].singletonId = -1;
        }

        active.splice(destroyIndex, 1); //index -= 1;
        //不同的位置的高度分开计算

        infoByPlacement[placement].distance -= destroyHeight + interval;
      }
    });

    (0, _reactDom.render)( /*#__PURE__*/React.createElement(Toast, (0, _extends2.default)({
      getIntanceHeight: handleInstanceHeight,
      ref: function ref(_ref2) {
        return instance = _ref2;
      }
    }, instanceOptions)), messageRoot);
    active.push(instance); //index += 1;

    this.destroy = function () {
      return instanceOptions.destroy.apply(instance);
    };
  });
  return function (options) {
    /**
     * 1、确保如果当前有多个实例那么只用最后一个实例
     * 2、如果之前保存的实例销毁了那么就用最后一个
     **/
    var singleton = options.singleton,
        _options$placement2 = options.placement,
        placement = _options$placement2 === void 0 ? 'top' : _options$placement2; //查找active中，placement的实例

    var activeByPlacement = active.filter(function (item) {
      return item.props.placement === placement;
    });

    if (activeByPlacement.length > 0 && singleton) {
      //单例也要查找相同位置的，否则重新新建一个
      var activeInstance;
      var singletonId = infoByPlacement[placement].singletonId;

      if (singletonId === -1) {
        //查找active中存在
        activeInstance = activeByPlacement[activeByPlacement.length - 1];
        infoByPlacement[placement].singletonId = activeInstance.id;
      } else {
        activeInstance = activeByPlacement.find(function (item) {
          return item.id === singletonId;
        });

        if (!activeInstance) {
          activeInstance = activeByPlacement[activeByPlacement.length - 1];
          infoByPlacement[placement].singletonId = activeInstance.id;
        }
      }

      return activeInstance.updateView(_objectSpread(_objectSpread({}, activeInstance.state), options));
    }

    return new Singleton(options);
  };
}();

['success', 'warning', 'info', 'error'].forEach(function (type) {
  Info[type] = function (content, duration) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return Info(_objectSpread({
      content: content,
      duration: duration,
      type: type
    }, options));
  };
});
var _default = Info;
exports.default = _default;