declare const _default: {
    rd: {
        common: {
            confirm: string;
            cancel: string;
            confirmTitle: string;
            test: string;
        };
        message: {
            know: string;
            placeholder: string;
        };
        select: {
            loading: string;
            noMatch: string;
            noData: string;
            placeholder: string;
        };
        form: {
            propNotValid: string;
        };
        pagination: {
            goto: string;
            pagesize: string;
            total: string;
        };
        upload: {
            uploadImg: string;
            clickToUpload: string;
            dragToUpload: string;
            dragNotSupported: string;
            notSupportedFile: string;
            notSupported: string;
            supportForExtensions: string;
            notValidImage: string;
            delete: string;
            preview: string;
            continue: string;
            selectFile: string;
            notSelected: string;
        };
        table: {
            emptyText: string;
            loading: string;
            clickAscending: string;
            clickDescending: string;
            unsort: string;
        };
        validator: {
            require: string;
            ip: string;
            ipStart127: string;
            ip223: string;
            mask: string;
            mac: string;
            byteRange: string;
            ssid: string;
            ascii: string;
            asciiRange: string;
            hex: string;
            hexRange: string;
            ssidPwd: string;
            email: string;
            domain: string;
            domainRange: string;
            numRange: string;
            portRange: string;
            maxChar: string;
            url: string;
            onlyNumber: string;
            serverName: string;
            date: string;
        };
        datepicker: {
            now: string;
            today: string;
            cancel: string;
            clear: string;
            confirm: string;
            selectDate: string;
            selectTime: string;
            startDate: string;
            startTime: string;
            endDate: string;
            endTime: string;
            year: string;
            month: string;
            month1: string;
            month2: string;
            month3: string;
            month4: string;
            month5: string;
            month6: string;
            month7: string;
            month8: string;
            month9: string;
            month10: string;
            month11: string;
            month12: string;
            weeks: {
                sun: string;
                mon: string;
                tue: string;
                wed: string;
                thu: string;
                fri: string;
                sat: string;
            };
            months: {
                jan: string;
                feb: string;
                mar: string;
                apr: string;
                may: string;
                jun: string;
                jul: string;
                aug: string;
                sep: string;
                oct: string;
                nov: string;
                dec: string;
            };
        };
    };
};
export default _default;
