import { Context } from 'react';
export interface MenuContextProps {
    mode?: string;
    hasIndicator?: boolean;
    selectedKeys?: Array<string | number>;
    openKeys?: Array<string | number>;
    ellipsis?: boolean;
    verticalShowLocation?: string;
    inlineIntent?: number | string;
    menuHandleHook?: {
        clickMenuItem: (e: React.MouseEvent<HTMLElement>, item: HTMLElement, index: string | number, indexPath: Array<string | number>) => void;
        openSubMenu: (index: string | number, indexPath: Array<string | number>) => void;
        getScrollContainer?: () => HTMLElement;
    };
}
declare const MenuContext: Context<MenuContextProps>;
export default MenuContext;
