"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _MenuContext = _interopRequireDefault(require("./MenuContext"));

var _Up = _interopRequireDefault(require("net-design-icons/lib/icons/Up"));

var _Down = _interopRequireDefault(require("net-design-icons/lib/icons/Down"));

var _Right = _interopRequireDefault(require("net-design-icons/lib/icons/Right"));

var _tool = _interopRequireDefault(require("./tool"));

var _collapse = _interopRequireDefault(require("../../libs/collapse"));

var _reactDom = require("react-dom");

var _excluded = ["disabled", "index", "prefixCls", "className", "subMenuClassName", "subMenuTitle", "icon", "ellipsis", "style", "children", "indexPath"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var SubMenu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(SubMenu, _React$Component);

  var _super = _createSuper(SubMenu);

  //timer: NodeJS.Timeout;

  /** */
  function SubMenu(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SubMenu);
    _this = _super.call(this, props);
    _this.subMenuWapper = void 0;
    _this.subMenuSubWrapper = void 0;

    _this.handleClick = function (e) {
      //展开，或者收起效果
      var _this$props = _this.props,
          index = _this$props.index,
          disabled = _this$props.disabled,
          indexPath = _this$props.indexPath;
      var menuHandleHook = _this.context.menuHandleHook;

      if (!disabled) {
        menuHandleHook.openSubMenu(index, indexPath);
      } else {
        e.stopPropagation();
        e.nativeEvent.stopImmediatePropagation();
      }
    };

    _this.handleMouseenter = function (e) {
      var index = _this.props.index;
      var openKeys = _this.context.openKeys;
      var isOpened = openKeys.find(function (item) {
        return item === index;
      });

      if (!isOpened) {
        //clearTimeout(this.timer);
        _this.getMenuSubWidth(); //this.timer = setTimeout(() => {


        _this.handleClick(e); //}, 100);

      }
    };

    _this.handleMouseleave = function (e) {
      var index = _this.props.index;
      var openKeys = _this.context.openKeys;
      var isOpened = openKeys.find(function (item) {
        return item === index;
      });

      if (isOpened) {
        //clearTimeout(this.timer);
        //this.timer = setTimeout(() => {
        _this.handleClick(e); //}, 100);

      }
    };

    _this.getMenuSubWidth = function () {
      //const menuSubElementWrapper = ReactDOM.findDOMNode(this.subMenuWapper);
      var rect = _this.subMenuWapper.getBoundingClientRect();

      var menuHandleHook = _this.context.menuHandleHook;
      var scrollContainerNode = menuHandleHook.getScrollContainer && menuHandleHook.getScrollContainer();
      var parentNode = scrollContainerNode ? scrollContainerNode : document.documentElement;
      var scrollTop = parentNode.scrollTop;

      _this.setState({
        verticalOffsetLeft: rect.x + rect.width,
        verticalOffsetTop: rect.y + scrollTop,
        verticalOffsetBottom: rect.y + scrollTop + rect.height
      });
    };

    _this.getIconName = function (mode, isOpened, hasIndicator) {
      if (hasIndicator) {
        if (mode === 'inline') {
          return isOpened ? /*#__PURE__*/React.createElement(_Up.default, null) : /*#__PURE__*/React.createElement(_Down.default, null);
        } else {
          return /*#__PURE__*/React.createElement(_Right.default, null); //垂直
        }
      } else {
        return '';
      }
    };

    _this.isChildrenSelected = function () {
      var children = _this.props.children;
      var selectedKeys = _this.context.selectedKeys;
      var ret = {
        find: false
      };

      _this.loopMenuItemRecursively(children, selectedKeys, ret);

      return ret.find;
    };

    _this.getLocation = function (verticalShowLocation) {
      var location = {};
      var _this$state = _this.state,
          stateVerticalLocation = _this$state.verticalLocation,
          verticalOffsetBottom = _this$state.verticalOffsetBottom,
          verticalOffsetTop = _this$state.verticalOffsetTop;
      var verticalLocation = stateVerticalLocation || (verticalShowLocation === 'auto' ? 'top' : verticalShowLocation);

      if (verticalLocation === 'top') {
        location = {
          top: verticalOffsetTop //bottom: 'auto'

        };
      } else if (verticalLocation === 'bottom') {
        //bottom的情况下，top位置要设置好，因为现在是放在body里面了
        var currentShowSumMenuRect = _this.subMenuSubWrapper.getBoundingClientRect();

        location = {
          top: verticalOffsetBottom - currentShowSumMenuRect.height //bottom: 'auto'

        };
      }

      return location;
    };

    _this.state = {
      verticalOffsetLeft: 200,
      verticalOffsetTop: 0,
      verticalOffsetBottom: 0
    };
    return _this;
  }
  /**
   * mode为垂直模式时，且子级菜单弹出位置固定为top时，当滚动条在底部，鼠标悬浮出现子级菜单，导致滚动条位置改变，需要设置位置保持不变
   *
   */


  (0, _createClass2.default)(SubMenu, [{
    key: "getSnapshotBeforeUpdate",
    value: function getSnapshotBeforeUpdate() {
      var _this$context = this.context,
          menuHandleHook = _this$context.menuHandleHook,
          mode = _this$context.mode;

      if (mode === 'vertical') {
        var scrollContainerNode = menuHandleHook.getScrollContainer && menuHandleHook.getScrollContainer();
        var parentNode = scrollContainerNode ? scrollContainerNode : document.documentElement;
        return {
          prevScrollTop: parentNode.scrollTop,
          prevScrollHeight: parentNode.scrollHeight,
          prevParentRect: parentNode.getBoundingClientRect() //currSubWrapper: this.subMenuSubWrapper

        };
      } else {
        return null;
      }
    }
    /**
     * 若有返回更新前的滚动条位置，则若滚动条位置有修改，则手动改变到以前的滚动条位置
     * @param prevProps
     * @param prevState
     * @param prevObj
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, prevObj) {
      var _this$context2 = this.context,
          menuHandleHook = _this$context2.menuHandleHook,
          mode = _this$context2.mode,
          verticalShowLocation = _this$context2.verticalShowLocation;
      var verticalLocation = prevState.verticalLocation;

      if (mode === 'vertical') {
        var scrollContainerNode = menuHandleHook.getScrollContainer && menuHandleHook.getScrollContainer();
        var parentNode = scrollContainerNode ? scrollContainerNode : document.documentElement;
        var currScrollTop = parentNode.scrollTop;

        if (currScrollTop > prevObj.prevScrollTop) {
          parentNode.scrollTop = prevObj.prevScrollTop;
        }

        if (verticalShowLocation === 'auto') {
          //需要根据当前显示出来的子菜单的高度与位置，是否大于了以前的scrollHeight，若大于，则使用bottom，否则，使用top
          var rect = this.subMenuSubWrapper.getBoundingClientRect();
          var titleRect = this.subMenuWapper.getBoundingClientRect(); //若，subMenu下的子菜单，计算底部相对于滚动条对象的位置(因为子菜单当前可能是top或者bottom，是变化的，所以此处使用title的top来确认弹出来的位置)

          var locationY = titleRect.top + rect.height;
          var parentY = prevObj.prevParentRect.top + prevObj.prevParentRect.height;

          if (locationY > parentY && verticalLocation !== 'bottom') {
            //则需要将样式设置为底部
            this.setState({
              verticalLocation: 'bottom'
            });
          } else if (locationY <= parentY && verticalLocation !== 'top') {
            this.setState({
              verticalLocation: 'top'
            });
          }
        }
      }
    }
    /**赋值上级内容verticalShowLocation */
    // componentDidMount(): void {
    //     /**此处会导致渲染两次 */
    //     this.setState({
    //         verticalLocation: this.context.verticalShowLocation
    //     });
    // }

  }, {
    key: "loopMenuItemRecursively",
    value:
    /**判断menuItem是否被选中，若被选中，则subMenu的样式要改变 */
    function loopMenuItemRecursively(children, keys, ret) {
      var _this2 = this;

      if (!children || ret.find) {
        return;
      }

      React.Children.forEach(children, function (c) {
        if (c) {
          var construct = c.type;

          if (!construct || !(construct.isMenuItem || construct.isSubMenu || construct.isMenuItemGroup)) {
            return;
          }

          if (keys.indexOf(c.props.index) !== -1) {
            ret.find = true;
          } else if (c.props.children) {
            _this2.loopMenuItemRecursively(c.props.children, keys, ret);
          }
        }
      });
    }
  }, {
    key: "render",
    value:
    /**
     *
     */
    function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          disabled = _this$props2.disabled,
          index = _this$props2.index,
          customizePrefixCls = _this$props2.prefixCls,
          className = _this$props2.className,
          subMenuClassName = _this$props2.subMenuClassName,
          subMenuTitle = _this$props2.subMenuTitle,
          icon = _this$props2.icon,
          itemEllipsis = _this$props2.ellipsis,
          style = _this$props2.style,
          children = _this$props2.children,
          indexPath = _this$props2.indexPath,
          others = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
      var _this$context3 = this.context,
          mode = _this$context3.mode,
          menuEllipsis = _this$context3.ellipsis,
          hasIndicator = _this$context3.hasIndicator,
          openKeys = _this$context3.openKeys,
          inlineIntent = _this$context3.inlineIntent,
          verticalShowLocation = _this$context3.verticalShowLocation;
      var ellipsis = itemEllipsis;

      if (typeof itemEllipsis === 'undefined') {
        ellipsis = menuEllipsis;
      }

      var prefixCls = (0, _util.getPrefixCls)('menu-submenu', customizePrefixCls);
      var isOpened = openKeys.find(function (item) {
        return item === index;
      });
      var isSelected = this.isChildrenSelected();
      var classNameString = (0, _classnames.default)(className, "".concat(prefixCls), {
        'is-selected': isSelected,
        'is-disabled': disabled,
        'is-open': isOpened,
        'has-indicator': hasIndicator,
        'has-icon': icon
      });
      var iconName = this.getIconName(mode, isOpened, hasIndicator);
      var subMenuTitleName = (0, _classnames.default)(subMenuClassName, "".concat(prefixCls, "--title"), {
        'is-ellipsis': ellipsis
      });
      var subMenuChildName = (0, _classnames.default)("".concat(prefixCls, "--sub"));
      var subMenuChildStyle = {};
      var titleProps = {};
      var subMenuProps = {};
      var titleStyle = {};

      if (mode !== 'inline') {
        subMenuProps = {
          onMouseEnter: this.handleMouseenter,
          onMouseLeave: this.handleMouseleave
        };
        var _this$state2 = this.state,
            verticalOffsetLeft = _this$state2.verticalOffsetLeft,
            verticalOffsetTop = _this$state2.verticalOffsetTop;
        var location = this.getLocation(verticalShowLocation);

        if (isOpened) {
          subMenuChildStyle = _objectSpread({
            left: verticalOffsetLeft,
            top: verticalOffsetTop
          }, location);
        } else {
          var width = this.subMenuSubWrapper ? this.subMenuSubWrapper.getBoundingClientRect().width : 200;
          subMenuChildStyle = {
            left: width > verticalOffsetLeft ? -width : -verticalOffsetLeft,
            top: verticalOffsetTop
          };
        }
      } else {
        titleProps = {
          onClick: this.handleClick
        };
        var level = (indexPath || []).length + 1;
        var unitMatch = inlineIntent.toString().match(/([a-z%]+)$/ig);
        var unit = unitMatch ? unitMatch[0] : 'px';
        titleStyle = {
          paddingLeft: "".concat(parseFloat(inlineIntent) * level).concat(unit)
        };
      }

      var subMenuStyle = _objectSpread({}, style);

      return /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        ref: function ref(div) {
          _this3.subMenuWapper = div;
        }
      }, subMenuProps, {
        className: classNameString,
        style: subMenuStyle
      }, others), /*#__PURE__*/React.createElement("div", (0, _extends2.default)({
        className: subMenuTitleName
      }, titleProps, {
        style: titleStyle
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "--title-inner")
      }, icon && /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "--icon")
      }, icon), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "--title-info")
      }, subMenuTitle), hasIndicator && /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "--indicator")
      }, iconName))), mode === 'inline' ? /*#__PURE__*/React.createElement(_collapse.default, {
        isShow: isOpened
      }, /*#__PURE__*/React.createElement("div", {
        className: subMenuChildName,
        style: subMenuChildStyle,
        ref: function ref(div) {
          _this3.subMenuSubWrapper = div;
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "inner"
      }, React.Children.map(children, function (c, i) {
        return (0, _tool.default)(c, _this3.props);
      })))) : /*#__PURE__*/(0, _reactDom.createPortal)( /*#__PURE__*/React.createElement("div", {
        className: "rd-menu rd-menu--vertical is-popup"
      }, /*#__PURE__*/React.createElement("div", {
        className: classNameString
      }, /*#__PURE__*/React.createElement("div", {
        className: subMenuChildName,
        style: subMenuChildStyle,
        ref: function ref(div) {
          _this3.subMenuSubWrapper = div;
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "inner"
      }, // eslint-disable-next-line @typescript-eslint/no-unused-vars
      React.Children.map(children, function (c, i) {
        return (0, _tool.default)(c, _this3.props);
      }))))), document.body));
    }
  }]);
  return SubMenu;
}(React.Component);

exports.default = SubMenu;
SubMenu.defaultProps = {
  disabled: false
};
SubMenu.isSubMenu = true;
SubMenu.contextType = _MenuContext.default;