"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var React = _interopRequireWildcard(require("react"));

var _Input = _interopRequireDefault(require("../input/Input"));

var _CaretUp = _interopRequireDefault(require("net-design-icons/lib/icons/CaretUp"));

var _CaretDown = _interopRequireDefault(require("net-design-icons/lib/icons/CaretDown"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _watch = _interopRequireDefault(require("../../libs/watch"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _FormElement = require("../form/FormElement");

var _ref = require("../../libs/ref");

var _util = require("../../libs/utils/util");

var _dec, _dec2, _dec3, _class, _class2, _class3;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MAX_SAFE_INTEGER = Math.pow(2, 53) - 1;
var MIN_SAFE_INTEGER = -MAX_SAFE_INTEGER;
var Number = (_dec = (0, _ref.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec3 = (0, _watch.default)('value'), _dec(_class = _dec2(_class = (0, _autoBind.default)(_class = (_class2 = (_class3 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Number, _React$Component);

  var _super = _createSuper(Number);

  /**
   * 构造函数
   * @param props
   */
  function Number(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Number);
    _this = _super.call(this, props);
    _this.state = void 0;
    _this.input = void 0;
    _this.hoveStyle = void 0;
    _this.state = {
      value: 0,
      showSuffix: props.upAndDownDefaultVisible,
      enterSuffer: false
    };
    _this.input = (0, _util.combineRef)(props);
    return _this;
  }
  /**
   *观察value值改变 会将props中的值合并到state中
   * 该方法不能删除
   */


  (0, _createClass2.default)(Number, [{
    key: "watchValue",
    value: function watchValue() {
      return null;
    }
    /**
     * 检查是否可点击
     */

  }, {
    key: "unClickAble",
    value: function unClickAble() {
      var _this$props = this.props,
          readOnly = _this$props.readOnly,
          disabled = _this$props.disabled;
      return readOnly || disabled;
    }
    /**
     * 数字加1
     */

  }, {
    key: "handleAdd",
    value: function handleAdd() {
      var _this$props3;

      var _this$props2 = this.props,
          allowNegative = _this$props2.allowNegative,
          allowZero = _this$props2.allowZero,
          allowPositive = _this$props2.allowPositive;

      if (this.unClickAble()) {
        return;
      }

      var value = this.limitValue(this.state.value);

      if (!value) {
        value = 0;
      }

      var newValue = parseFloat(value + '') + 1;

      if (newValue === 0 && !allowZero) {
        if (allowPositive) {
          newValue = newValue + 1;
        } else {
          newValue = parseFloat(value + '');
        }
      } else if (newValue > 0 && !allowPositive) {
        newValue = parseFloat(value + '');
      } else if (newValue < 0 && !allowNegative) {
        newValue = parseFloat(value + '');
      }

      (_this$props3 = this.props) === null || _this$props3 === void 0 ? void 0 : _this$props3.onChange(newValue);
    }
    /**
     * 数字减1
     */

  }, {
    key: "handleSub",
    value: function handleSub() {
      var _this$props5;

      var _this$props4 = this.props,
          allowNegative = _this$props4.allowNegative,
          allowZero = _this$props4.allowZero,
          allowPositive = _this$props4.allowPositive;

      if (this.unClickAble()) {
        return;
      }

      var value = this.limitValue(this.state.value);

      if (!value) {
        value = 0;
      }

      var newValue = parseFloat(value + '') - 1;

      if (newValue === 0 && !allowZero) {
        if (allowNegative) {
          newValue = newValue - 1;
        } else {
          newValue = parseFloat(value + '');
        }
      } else if (newValue > 0 && !allowPositive) {
        newValue = parseFloat(value + '');
      } else if (newValue < 0 && !allowNegative) {
        newValue = parseFloat(value + '');
      }

      (_this$props5 = this.props) === null || _this$props5 === void 0 ? void 0 : _this$props5.onChange(newValue);
    }
    /**
     * 处理聚焦事件
     * @param e
     */

  }, {
    key: "handleFocus",
    value: function handleFocus(e) {
      var _this$props6 = this.props,
          onFocus = _this$props6.onFocus,
          upAndDownDefaultVisible = _this$props6.upAndDownDefaultVisible;

      if (!upAndDownDefaultVisible) {
        this.setState({
          showSuffix: true
        });
      }

      if (onFocus) {
        onFocus(e);
      }
    }
    /**
     * 处理失去焦点事件
     * @param e
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var _this$props7 = this.props,
          onBlur = _this$props7.onBlur,
          upAndDownDefaultVisible = _this$props7.upAndDownDefaultVisible;
      var enterSuffer = this.state.enterSuffer;

      if (!enterSuffer) {
        var allowZero = this.props.allowZero;
        var _value = this.state.value;

        if (!allowZero && parseFloat(_value + '') === 0) {
          this.setState({
            value: ''
          });
        }

        if (!upAndDownDefaultVisible) {
          this.setState({
            showSuffix: false
          });
        }

        if (onBlur) {
          onBlur(e);
        }
      }
    }
    /**
     * 鼠标移入事件
     */

  }, {
    key: "handleHover",
    value: function handleHover() {
      this.input.current.focus();

      if (this.hoveStyle) {
        this.hoveStyle = document.body.getAttribute('style');
      }

      document.body.style.userSelect = 'none';
      this.setState({
        enterSuffer: true
      });
    }
    /**
     * 鼠标离开事件
     */

  }, {
    key: "handleLeave",
    value: function handleLeave() {
      if (!this.hoveStyle) {
        document.body.removeAttribute('style');
      } else {
        document.body.setAttribute('style', this.hoveStyle);
      }

      this.setState({
        enterSuffer: false
      });
    }
    /**
     * 值改变的回调
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var onChange = this.props.onChange;
      this.setActualValue(this.limitValue(e.target.value), function (newValue) {
        onChange && onChange(parseFloat(newValue));
      });
    }
    /**
     * 根据实际的prop设置限制输入
     * @param newValue
     * @param callback
     */

  }, {
    key: "setActualValue",
    value: function setActualValue(newValue, callback) {
      var _this$props8 = this.props,
          allowFloat = _this$props8.allowFloat,
          allowZeroStart = _this$props8.allowZeroStart,
          allowNegative = _this$props8.allowNegative,
          allowPositive = _this$props8.allowPositive;
      var regexp = new RegExp("^".concat(allowNegative ? '(-?)' : '', "[0-9]*").concat(allowFloat ? '\\.?' : '', "[0-9]*$"));

      if (!allowPositive) {
        regexp = new RegExp("^-[0-9]*".concat(allowFloat ? '\\.?' : '', "[0-9]*$"));
      }

      if (regexp.test(newValue + '')) {
        if (!allowZeroStart && "".concat(newValue).startsWith('0') && !"".concat(newValue).startsWith('0.')) {
          newValue = parseFloat(newValue);
        }

        callback && callback(newValue);
      }
    }
    /**
     * 设置值在安全值范围之间
     */

  }, {
    key: "limitValue",
    value: function limitValue(value) {
      var _this$props9 = this.props,
          min = _this$props9.min,
          max = _this$props9.max;

      if (value > max) {
        value = "".concat(value).slice(0, "".concat(max).length);

        if (value > max) {
          value = max;
        }
      }

      if (value < min) {
        value = "".concat(value).slice(0, "".concat(min).length);

        if (value < min) {
          value = min;
        }
      }

      return value;
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var suffix = this.props.suffix;
      var showSuffix = this.state.showSuffix;

      if (showSuffix) {
        suffix = {
          children: /*#__PURE__*/React.createElement("div", {
            className: "rd-input__number"
          }, /*#__PURE__*/React.createElement(_CaretUp.default, {
            onClick: this.handleAdd
          }), /*#__PURE__*/React.createElement(_CaretDown.default, {
            onClick: this.handleSub
          })),
          onMouseOver: this.handleHover,
          onMouseLeave: this.handleLeave
        };
      }

      var newValue = '';
      this.setActualValue(this.limitValue(this.state.value), function (value) {
        newValue = value;
      });
      return /*#__PURE__*/React.createElement(_Input.default, (0, _extends2.default)({}, (0, _omit.default)(this.props, ['allowZero', 'allowFloat', 'allowNegative', 'allowPositive', 'allowZeroStart', 'upAndDownDefaultVisible', 'min', 'max']), {
        ref: this.input,
        type: 'text',
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onChange: this.handleChange,
        onCompositionStart: function onCompositionStart(e) {
          var event = e;

          _this2.handleChange(event);
        },
        onCompositionEnd: function onCompositionEnd(e) {
          var event = e;

          _this2.handleChange(event);
        },
        suffix: suffix,
        value: newValue
      }));
    }
  }]);
  return Number;
}(React.Component), _class3.defaultProps = {
  /**默认的最大值**/
  max: MAX_SAFE_INTEGER,

  /**默认的最小值**/
  min: MIN_SAFE_INTEGER,

  /**允许正数**/
  allowPositive: true,

  /**允许负数**/
  allowNegative: true,

  /**允许0**/
  allowZero: true,

  /**允许浮点数**/
  allowFloat: true,

  /**数字输入框的up和down 图标是否默认显示**/
  upAndDownDefaultVisible: true
}, _class3), ((0, _applyDecoratedDescriptor2.default)(_class2.prototype, "watchValue", [_dec3], Object.getOwnPropertyDescriptor(_class2.prototype, "watchValue"), _class2.prototype)), _class2)) || _class) || _class) || _class);
exports.default = Number;