"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _More = _interopRequireDefault(require("net-design-icons/lib/icons/More"));

var _DoubleArrowLeft = _interopRequireDefault(require("net-design-icons/lib/icons/DoubleArrowLeft"));

var _DoubleArrowRight = _interopRequireDefault(require("net-design-icons/lib/icons/DoubleArrowRight"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Pager = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Pager, _React$Component);

  var _super = _createSuper(Pager);

  /**
   * 构造函数
   * @param props
   */
  function Pager(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Pager);
    _this = _super.call(this, props);
    _this.state = {
      internalCurrentPage: 1,
      internalPageSize: 0,
      quickPrevIcon: /*#__PURE__*/React.createElement(_More.default, {
        className: "rd-pagination__icon"
      }),
      quickNextIcon: /*#__PURE__*/React.createElement(_More.default, {
        className: "rd-pagination__icon"
      }),
      showPrevMore: false,
      showNextMore: false,
      currentPage: null,
      pageCount: null,
      pagers: []
    };
    return _this;
  }
  /**
   * 点击li执行的回调
   * @param e
   */


  (0, _createClass2.default)(Pager, [{
    key: "handlePagerClick",
    value: function handlePagerClick(e) {
      var _this2 = this;

      /**
       * 提出来的目的降低圈复杂度
       * @param target
       * @param currentPage
       */
      var quickClick = function quickClick(target, currentPage) {
        var middlePageNum = _this2.props.middlePageNum; // 获取li内容

        var newPage = Number(target.textContent);

        if (target.className.indexOf('more') !== -1) {
          if (target.className.indexOf('quickprev') !== -1) {
            newPage = currentPage - middlePageNum;
          } else if (target.className.indexOf('quicknext') !== -1) {
            newPage = currentPage + middlePageNum;
          }
        }

        return newPage;
      };

      var target = e.target;

      if (target instanceof HTMLElement) {
        if (target.tagName === 'UL') {
          return;
        }

        while (target.tagName !== 'LI') {
          target = target.parentNode;
        }

        var _this$props = this.props,
            pageCount = _this$props.pageCount,
            currentPage = _this$props.currentPage,
            onChange = _this$props.onChange;
        var newPage = quickClick(target, currentPage);
        /* istanbul ignore if */

        if (!isNaN(newPage)) {
          if (newPage < 1) {
            newPage = 1;
          }

          if (newPage > pageCount) {
            newPage = pageCount;
          }
        }

        if (newPage !== currentPage) {
          onChange && onChange(newPage);
        }
      }
    }
    /**
      *
      * @param nextProps
      * @param prevState
      */

  }, {
    key: "render",
    value:
    /**
     * render
     */
    function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          currentPage = _this$props2.currentPage,
          pageCount = _this$props2.pageCount;
      var _this$state = this.state,
          quickPrevIcon = _this$state.quickPrevIcon,
          quickNextIcon = _this$state.quickNextIcon,
          showPrevMore = _this$state.showPrevMore,
          showNextMore = _this$state.showNextMore,
          pagers = _this$state.pagers;
      return /*#__PURE__*/React.createElement("ul", {
        onClick: this.handlePagerClick,
        className: "rd-pager"
      }, pageCount > 0 && /*#__PURE__*/React.createElement("li", {
        className: (0, _classnames.default)('number', ' rd-pagination__flex', {
          active: currentPage === 1
        })
      }, "1"), showPrevMore && /*#__PURE__*/React.createElement("li", {
        className: (0, _classnames.default)('more btn-quickprev', ' rd-pagination__flex'),
        onMouseEnter: function onMouseEnter() {
          _this3.setState({
            quickPrevIcon: /*#__PURE__*/React.createElement(_DoubleArrowLeft.default, {
              className: "rd-pagination__icon"
            })
          });
        },
        onMouseLeave: function onMouseLeave() {
          _this3.setState({
            quickPrevIcon: /*#__PURE__*/React.createElement(_More.default, {
              className: "rd-pagination__icon"
            })
          });
        }
      }, quickPrevIcon), pagers.map(function (pager, idx) {
        return /*#__PURE__*/React.createElement("li", {
          key: idx,
          className: (0, _classnames.default)('number', ' rd-pagination__flex', {
            active: currentPage === pager
          })
        }, pager);
      }), showNextMore && /*#__PURE__*/React.createElement("li", {
        className: (0, _classnames.default)('more btn-quicknext', ' rd-pagination__flex'),
        onMouseEnter: function onMouseEnter() {
          _this3.setState({
            quickNextIcon: /*#__PURE__*/React.createElement(_DoubleArrowRight.default, {
              className: "rd-pagination__icon"
            })
          });
        },
        onMouseLeave: function onMouseLeave() {
          _this3.setState({
            quickNextIcon: /*#__PURE__*/React.createElement(_More.default, {
              className: "rd-pagination__icon"
            })
          });
        }
      }, quickNextIcon), pageCount > 1 && /*#__PURE__*/React.createElement("li", {
        className: (0, _classnames.default)('number', ' rd-pagination__flex', {
          active: currentPage === pageCount
        })
      }, pageCount));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      return _objectSpread({}, Pager.getPages(nextProps, prevState));
    }
    /**
     * 获取页码数组[1,2,3,4,5...]
     */

  }, {
    key: "getPages",
    value: function getPages(nextProps, prevState) {
      var currentPage = nextProps.currentPage,
          pageCount = nextProps.pageCount,
          middlePageNum = nextProps.middlePageNum;
      var pagerShowNum = middlePageNum + 2;
      var showPrevMore = false;
      var showNextMore = false;

      if (pageCount > pagerShowNum) {
        if (currentPage > middlePageNum && currentPage - middlePageNum !== 1) {
          showPrevMore = true;
        }

        if (currentPage < pageCount - middlePageNum + 2 && pageCount - currentPage !== 1) {
          showNextMore = true;
        }
      }

      var getArray = function getArray() {
        var array = [];
        var intVal, count;

        if (showPrevMore && !showNextMore) {
          var startPage = pageCount - middlePageNum;
          intVal = startPage;
          count = pageCount;
        } else if (!showPrevMore && showNextMore) {
          intVal = 2;
          count = pagerShowNum;
        } else if (showPrevMore && showNextMore) {
          var offset = Math.floor(pagerShowNum / 2) - 1;
          intVal = currentPage - offset;
          count = currentPage + middlePageNum - offset;
        } else {
          intVal = 2;
          count = pageCount;
        }

        for (var i = intVal; i < count; i++) {
          array.push(i);
        }

        return array;
      };

      var array = getArray();
      var quickNextIcon = prevState.quickNextIcon,
          quickPrevIcon = prevState.quickPrevIcon;
      return {
        pagers: array,
        showPrevMore: showPrevMore,
        showNextMore: showNextMore,
        quickPrevIcon: showPrevMore ? quickPrevIcon : /*#__PURE__*/React.createElement(_More.default, {
          className: "rd-pagination__icon"
        }),
        quickNextIcon: showNextMore ? quickNextIcon : /*#__PURE__*/React.createElement(_More.default, {
          className: "rd-pagination__icon"
        })
      };
    }
  }]);
  return Pager;
}(React.Component)) || _class;

exports.default = Pager;