"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _EyeLine = _interopRequireDefault(require("net-design-icons/lib/icons/EyeLine"));

var _EyeOffLine = _interopRequireDefault(require("net-design-icons/lib/icons/EyeOffLine"));

var _FormElement = require("../form/FormElement");

var _Input = _interopRequireDefault(require("../input/Input"));

var _util = require("../../libs/utils/util");

var _ref2 = require("../../libs/ref");

var _excluded = ["icon", "style"];

var _dec, _dec2, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Password = (_dec = (0, _ref2.forwardRef)(), _dec2 = (0, _FormElement.createFormElement)(), _dec(_class = _dec2(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Password, _React$Component);

  var _super = _createSuper(Password);

  /**
   * 构造函数
   * @param props
   */
  function Password(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Password);
    _this = _super.call(this, props);
    _this.inputRef = void 0;
    _this.state = void 0;
    _this.inputRef = (0, _util.combineRef)(props);

    var _Password$defaultProp = _objectSpread(_objectSpread({}, Password.defaultProps.password), props.password),
        defaultEncrypt = _Password$defaultProp.defaultEncrypt;

    _this.state = {
      focus: false,
      passwordType: defaultEncrypt
    };
    return _this;
  }

  (0, _createClass2.default)(Password, [{
    key: "handleFocus",
    value:
    /**
     * 处理聚焦事件
     * @param e
     */
    function handleFocus(e) {
      var _this$props = this.props,
          onFocus = _this$props.onFocus,
          password = _this$props.password;
      var passwordType = this.state.passwordType;

      var _Password$defaultProp2 = _objectSpread(_objectSpread({}, Password.defaultProps.password), password),
          focusBlurChangePasswordType = _Password$defaultProp2.focusBlurChangePasswordType;

      if (focusBlurChangePasswordType) {
        this.setState({
          passwordType: !passwordType
        });
      }

      if (onFocus) {
        onFocus(e);
      }
    }
    /**
     * 处理失去焦点事件
     * @param e
     */

  }, {
    key: "handleBlur",
    value: function handleBlur(e) {
      var _this$props2 = this.props,
          onBlur = _this$props2.onBlur,
          password = _this$props2.password;
      var passwordType = this.state.passwordType;

      var _Password$defaultProp3 = _objectSpread(_objectSpread({}, Password.defaultProps.password), password),
          focusBlurChangePasswordType = _Password$defaultProp3.focusBlurChangePasswordType;

      if (focusBlurChangePasswordType) {
        this.setState({
          passwordType: !passwordType
        });
      }

      if (onBlur) {
        onBlur(e);
      }
    }
    /**
     *设置光标位置
     */

  }, {
    key: "handleSwitchPassword",
    value:
    /**
     * 处理密码切换
     */
    function handleSwitchPassword(event) {
      var _this2 = this;

      var passwordType = this.state.passwordType;
      var _this$props3 = this.props,
          readOnly = _this$props3.readOnly,
          disabled = _this$props3.disabled;

      if (readOnly || disabled) {
        return;
      }

      var password = this.props.password;
      password = _objectSpread(_objectSpread({}, Password.defaultProps.password), password);
      var caretPosition = this.inputRef.current.value.length;
      password.onClick && password.onClick(event);
      password.onSwitch && password.onSwitch(passwordType);
      this.setState(function (_ref) {
        var passwordType = _ref.passwordType;
        return {
          passwordType: !passwordType
        };
      }, function () {
        setTimeout(function () {
          Password.setCaretPosition(_this2.inputRef.current, caretPosition);
        }, 0);
      });
    }
    /**
     * 得到密码的cursor
     */

  }, {
    key: "getPasswordCursor",
    value: function getPasswordCursor() {
      var _this$props4 = this.props,
          readOnly = _this$props4.readOnly,
          disabled = _this$props4.disabled;
      return readOnly || disabled ? '' : 'pointer';
    }
    /**
     *得到prefix或者suffix
     */

  }, {
    key: "getFix",
    value: function getFix() {
      var _this$props5 = this.props,
          prefixIcon = _this$props5.prefix,
          suffixIcon = _this$props5.suffix;
      var password = this.props.password;
      password = _objectSpread(_objectSpread({}, Password.defaultProps.password), password);
      var _password = password,
          showPassword = _password.showPassword;

      var generator = function generator(icon) {
        var fix;

        if (icon && icon.hasOwnProperty('props')) {
          fix = {
            children: icon
          };
        } else if ((0, _typeof2.default)(icon) === 'object') {
          fix = icon;
        } else {
          fix = {
            children: icon && /*#__PURE__*/React.createElement("span", {
              className: "fix_default"
            }, icon)
          };
        }

        return fix;
      };

      var _suffix = [];

      if (suffixIcon) {
        if (Array.isArray(suffixIcon)) {
          _suffix = suffixIcon.map(function (suffix) {
            return generator(suffix);
          });
        } else {
          _suffix = [generator(suffixIcon)];
        }
      }

      var passwordType = this.state.passwordType;
      var _password2 = password,
          icon = _password2.icon,
          style = _password2.style,
          rest = (0, _objectWithoutProperties2.default)(_password2, _excluded);
      var otherProps = (0, _omit.default)(rest, ['showPassword', 'defaultEncrypt', 'focusBlurChangePasswordType', 'onSwitch']);
      var suffix = (0, _toConsumableArray2.default)(_suffix);

      if (showPassword) {
        suffix.push(_objectSpread(_objectSpread({}, otherProps), {}, {
          children: icon ? icon : /*#__PURE__*/React.createElement(React.Fragment, null, passwordType ? /*#__PURE__*/React.createElement(_EyeOffLine.default, null) : /*#__PURE__*/React.createElement(_EyeLine.default, null)),
          className: 'icon-pass',
          style: style ? style : {
            cursor: this.getPasswordCursor()
          },
          onClick: this.handleSwitchPassword
        }));
      }

      return {
        prefix: prefixIcon,
        suffix: suffix
      };
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var passwordType = this.state.passwordType;

      var _this$getFix = this.getFix(),
          suffix = _this$getFix.suffix,
          prefix = _this$getFix.prefix;

      var otherProps = (0, _omit.default)(this.props, ['password', 'forwardRef']);
      var inputType = passwordType ? 'password' : 'text';

      var renderProps = _objectSpread(_objectSpread({}, otherProps), {}, {
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      });

      return /*#__PURE__*/React.createElement(_Input.default, (0, _extends2.default)({}, renderProps, {
        ref: this.inputRef,
        type: inputType,
        suffix: suffix,
        prefix: prefix
      }));
    }
  }], [{
    key: "setCaretPosition",
    value: function setCaretPosition(textDom, pos) {
      if (textDom.setSelectionRange) {
        // IE Support
        textDom.focus();
        textDom.setSelectionRange(pos, pos);
      } else if (textDom.createTextRange) {
        // Firefox support
        var range = textDom.createTextRange();
        range.collapse(true);
        range.moveEnd('character', pos);
        range.moveStart('character', pos);
        range.select();
      }
    }
  }]);
  return Password;
}(React.Component), _class2.defaultProps = {
  password: {
    defaultEncrypt: true,
    showPassword: true,
    focusBlurChangePasswordType: false
  }
}, _class2)) || _class) || _class) || _class);
exports.default = Password;