import * as React from 'react';
import { RadioProps, CheckboxValueType } from './interface';
interface RadioGroupState {
    value?: string | number;
    _prevProps?: RadioProps;
    model?: string | number;
}
export default class RadioGroup extends React.Component<RadioProps, RadioGroupState> {
    /**
     *
     * @param props
     */
    constructor(props: RadioProps);
    static defaultProps: {
        size: string;
    };
    /**
   * 更新父级
   * @param nextProps
   * @param prevState
   */
    static getDerivedStateFromProps(nextProps: RadioProps, prevState: RadioGroupState): RadioGroupState;
    /**
     *
     * @param e
     */
    onChange(value: CheckboxValueType): void;
    /**
     *
     * @param e
     */
    onClick(value: CheckboxValueType): void;
    /**
     *
     */
    render(): React.ReactNode;
}
export {};
