import * as React from 'react';
import Radio from './Radio';
import { RadioProps } from './interface';
export default class RadioButton extends Radio {
    static defaultProps: {
        size: string;
    };
    /**
     * 初始化
     */
    componentDidMount(): void;
    /**
     * 更新
     * @param nextProps
     * @param prevState
     */
    componentDidUpdate(prevProps: RadioProps): void;
    /**
     * 获取父级尺寸
     */
    size(): string;
    /**
     * 获取填充颜色
     */
    activeStyle(): {
        backgroundColor: string;
        borderColor: string;
        color: string;
    };
    /**button渲染 */
    buttonRender(): React.ReactNode;
    /**
     *渲染
     */
    render(): React.ReactNode;
}
