"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _util = require("../../libs/utils/util");

var _RotateIcon = _interopRequireDefault(require("./RotateIcon"));

var _LoaderLine = _interopRequireDefault(require("net-design-icons/lib/icons/LoaderLine"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Spin = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Spin, _React$Component);

  var _super = _createSuper(Spin);

  function Spin() {
    var _this;

    (0, _classCallCheck2.default)(this, Spin);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Spin, [{
    key: "getIcon",
    value:
    /**得到旋转图标 */
    function getIcon(prefixCls) {
      var _this$props = this.props,
          icon = _this$props.icon,
          iconStyle = _this$props.iconStyle,
          size = _this$props.size,
          customizePrefixCls = _this$props.prefixCls;
      var loading = this.state.loading;
      var iconNode = icon ? icon(loading) : /*#__PURE__*/React.createElement(_LoaderLine.default, null);
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_RotateIcon.default, {
        className: "".concat(prefixCls, "__icon"),
        loading: loading,
        style: iconStyle,
        size: size,
        prefixCls: customizePrefixCls
      }, iconNode));
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          fullScreen = _this$props2.fullScreen,
          text = _this$props2.text,
          className = _this$props2.className,
          style = _this$props2.style,
          children = _this$props2.children,
          size = _this$props2.size,
          customizePrefixCls = _this$props2.prefixCls;
      var loading = this.state.loading;
      var prefixCls = (0, _util.getPrefixCls)('spin', customizePrefixCls);
      var classString = (0, _classnames.default)(className, "".concat(prefixCls), fullScreen && "".concat(prefixCls, "__wrapper is-fullscreen"), "".concat(prefixCls, "--").concat(size), children && "".concat(prefixCls, "__wrapper"), text && 'has-text');
      var reactJsx = /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__info")
      }, this.getIcon(prefixCls), text && /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "__text")
      }, text)));
      return /*#__PURE__*/React.createElement(React.Fragment, null, loading && (fullScreen ? /*#__PURE__*/(0, _reactDom.createPortal)(reactJsx, document.body) : reactJsx), children);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**返回当前状态 */
    function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.loading !== prevState.loading) {
        return {
          loading: nextProps.loading
        };
      }

      return null;
    }
  }]);
  return Spin;
}(React.Component), _class2.defaultProps = {
  size: 'medium'
}, _class2)) || _class;

exports.default = Spin;