import { Context } from 'react';
export declare const Status: ["finish", "process", "wait", "error", "disable"];
export declare const Position: ["bottom"];
export declare const Direction: ["horizontal", "vertical"];
export interface StepsContextProps {
    current?: number;
    labelPosition?: typeof Position[number];
    space?: number;
    status?: typeof Status[number];
    /**Step个数 */
    count?: number;
    onChange?: (stepNumber: number, e: MouseEvent) => void;
}
declare const StepsContext: Context<StepsContextProps>;
export default StepsContext;
