"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Status = exports.Position = exports.Direction = void 0;

var _react = require("react");

var _types = require("../../libs/types");

var Status = (0, _types.tuple)('finish', 'process', 'wait', 'error', 'disable');
exports.Status = Status;
var Position = (0, _types.tuple)('bottom');
exports.Position = Position;
var Direction = (0, _types.tuple)('horizontal', 'vertical');
exports.Direction = Direction;
var StepsContext = /*#__PURE__*/(0, _react.createContext)({});
var _default = StepsContext;
exports.default = _default;