"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TagTypeTypes = (0, _types.tuple)('success', 'info', 'danger', 'warning');
var TagThemeTypes = (0, _types.tuple)('dark', 'light', 'plain');

var Tag = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Tag, _React$Component);

  var _super = _createSuper(Tag);

  function Tag() {
    (0, _classCallCheck2.default)(this, Tag);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Tag, [{
    key: "handleClose",
    value:
    /**
     * 关闭
     * @param e
     */
    function handleClose(e) {
      var onClose = this.props.onClose;
      onClose && onClose(e);
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          type = _this$props.type,
          style = _this$props.style,
          theme = _this$props.theme,
          children = _this$props.children,
          size = _this$props.size,
          closable = _this$props.closable;
      var classes = (0, _classnames.default)('rd-tag', className, {
        'rd-tag--success': type === 'success',
        'rd-tag--info': type === 'info',
        'rd-tag--danger': type === 'danger',
        'rd-tag--warning': type === 'warning',
        'rd-tag--dark': theme === 'dark',
        'rd-tag--light': theme === 'light',
        'rd-tag--plain': theme === 'plain',
        'rd-tag--large': size === 'large',
        'rd-tag--medium': size === 'medium',
        'rd-tag--small': size === 'small'
      });
      return /*#__PURE__*/React.createElement("span", {
        className: classes,
        style: _objectSpread({}, style)
      }, /*#__PURE__*/React.createElement("span", {
        className: "rd-tag__msg"
      }, children), closable && /*#__PURE__*/React.createElement(_Close.default, {
        className: "rd-tag__close",
        onClick: this.handleClose
      }));
    }
  }]);
  return Tag;
}(React.Component), _class2.defaultProps = {
  closable: false,
  size: 'small'
}, _class2.Group = void 0, _class2.TagGroup = void 0, _class2)) || _class;

exports.default = Tag;