"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var React = _interopRequireWildcard(require("react"));

var _EyeLine = _interopRequireDefault(require("net-design-icons/lib/icons/EyeLine"));

var _Delete = _interopRequireDefault(require("net-design-icons/lib/icons/Delete"));

var _Close = _interopRequireDefault(require("net-design-icons/lib/icons/Close"));

var _AttachmentLine = _interopRequireDefault(require("net-design-icons/lib/icons/AttachmentLine"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _span = _interopRequireDefault(require("../span"));

var _watch = _interopRequireDefault(require("../../libs/watch"));

var _locale = _interopRequireDefault(require("../locale"));

var _dec, _class, _class2, _class3;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Preview = (_dec = (0, _watch.default)('percent'), (0, _autoBind.default)(_class = (_class2 = (_class3 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Preview, _React$Component);

  var _super = _createSuper(Preview);

  function Preview() {
    var _this;

    (0, _classCallCheck2.default)(this, Preview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      visible: false
    };
    return _this;
  }

  (0, _createClass2.default)(Preview, [{
    key: "watchValue",
    value:
    /**
     * 监视percent变化
     */
    function watchValue() {
      return null;
    }
    /**
     *关闭
     */

  }, {
    key: "handleDelete",
    value: function handleDelete() {
      var onDelete = this.props.onDelete;
      onDelete && onDelete();
    }
    /**
     *
     */

  }, {
    key: "handleErrImage",
    value: function handleErrImage() {
      var _this$props = this.props,
          onError = _this$props.onError,
          percent = _this$props.percent;
      /**
       * percent 刷新也会导致重新渲染
       */

      if (percent === 0) {
        onError && onError({
          msg: _locale.default.t('rd.upload.notValidImage')
        });
      }
    }
    /**
     * 查看
     */

  }, {
    key: "handleView",
    value: function handleView() {
      this.setState({
        visible: true
      });
    }
    /**
     * 关闭dialog
     */

  }, {
    key: "handleCloseDialog",
    value: function handleCloseDialog() {
      this.setState({
        visible: false
      });
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          name = _this$props2.name,
          url = _this$props2.url,
          type = _this$props2.type,
          maxWidth = _this$props2.maxWidth;
      var _this$state = this.state,
          visible = _this$state.visible,
          percent = _this$state.percent;
      var Config = {
        card: function card() {
          return /*#__PURE__*/React.createElement("div", {
            className: "card-item"
          }, /*#__PURE__*/React.createElement("div", {
            className: "card-item-mask"
          }, /*#__PURE__*/React.createElement("div", {
            className: "card-item-action"
          }, /*#__PURE__*/React.createElement(_EyeLine.default, {
            onClick: this.handleView
          }), /*#__PURE__*/React.createElement(_Delete.default, {
            onClick: this.handleDelete
          }))), visible && /*#__PURE__*/React.createElement("div", {
            className: "card-item-dialog"
          }, /*#__PURE__*/React.createElement("div", {
            className: "card-item-dialog-mask",
            onClick: this.handleCloseDialog
          }), /*#__PURE__*/React.createElement("div", {
            className: "card-item-body-wrapper"
          }, /*#__PURE__*/React.createElement("div", {
            className: "card-item-dialog-body"
          }, /*#__PURE__*/React.createElement("div", {
            className: "card-item-dialog-header"
          }, /*#__PURE__*/React.createElement(_span.default, {
            className: "card-item-dialog-title",
            title: name
          }, name), /*#__PURE__*/React.createElement(_Close.default, {
            className: "close",
            onClick: this.handleCloseDialog
          })), url ? /*#__PURE__*/React.createElement("img", {
            src: url,
            onError: this.handleErrImage,
            alt: ""
          }) : /*#__PURE__*/React.createElement("svg", {
            viewBox: "0 0 1170 1024"
          }, /*#__PURE__*/React.createElement("path", {
            d: "M1143.6032 0a24.283429 24.283429 0 0 1 24.312686 24.283429v972.010057a24.283429 24.283429 0 0 1-24.283429 24.283428H25.775543a24.283429 24.283429 0 0 1-24.283429-24.283428l-0.058514-215.04a24.283429 24.283429 0 0 1 0-7.314286L1.521371 24.283429A24.283429 24.283429 0 0 1 25.8048 0h1117.7984zM830.639543 447.107657l-276.041143 322.238172a24.283429 24.283429 0 0 1-33.557943 2.925714l-227.913143-182.272-243.009828 199.358171v182.652343h1069.202285l-0.029257-280.546743-288.650971-244.355657z m288.680228-398.482286H50.117486v677.390629l227.445028-186.075429a24.283429 24.283429 0 0 1 30.632229 0l224.987428 179.8144 276.0704-322.706285a24.283429 24.283429 0 0 1 34.026058-2.428343l276.011885 233.559771V48.596114zM534.001371 203.629714a121.504914 121.504914 0 1 1-92.9792 224.490057 121.504914 121.504914 0 0 1 92.9792-224.490057z m-46.4896 39.350857a72.9088 72.9088 0 1 0 0 145.788343 72.9088 72.9088 0 0 0 0-145.788343z"
          }))))), url ? /*#__PURE__*/React.createElement("img", {
            src: url,
            onError: this.handleErrImage,
            alt: ""
          }) : /*#__PURE__*/React.createElement("svg", {
            viewBox: "0 0 1170 1024"
          }, /*#__PURE__*/React.createElement("path", {
            d: "M1143.6032 0a24.283429 24.283429 0 0 1 24.312686 24.283429v972.010057a24.283429 24.283429 0 0 1-24.283429 24.283428H25.775543a24.283429 24.283429 0 0 1-24.283429-24.283428l-0.058514-215.04a24.283429 24.283429 0 0 1 0-7.314286L1.521371 24.283429A24.283429 24.283429 0 0 1 25.8048 0h1117.7984zM830.639543 447.107657l-276.041143 322.238172a24.283429 24.283429 0 0 1-33.557943 2.925714l-227.913143-182.272-243.009828 199.358171v182.652343h1069.202285l-0.029257-280.546743-288.650971-244.355657z m288.680228-398.482286H50.117486v677.390629l227.445028-186.075429a24.283429 24.283429 0 0 1 30.632229 0l224.987428 179.8144 276.0704-322.706285a24.283429 24.283429 0 0 1 34.026058-2.428343l276.011885 233.559771V48.596114zM534.001371 203.629714a121.504914 121.504914 0 1 1-92.9792 224.490057 121.504914 121.504914 0 0 1 92.9792-224.490057z m-46.4896 39.350857a72.9088 72.9088 0 1 0 0 145.788343 72.9088 72.9088 0 0 0 0-145.788343z"
          })));
        },
        list: function list() {
          return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
            className: "preview-item"
          }, /*#__PURE__*/React.createElement(_AttachmentLine.default, null), /*#__PURE__*/React.createElement(_span.default, {
            className: "preview-item-span",
            style: maxWidth && {
              maxWidth: "calc(".concat(maxWidth, "px - 4em)")
            },
            title: name !== undefined ? name : url
          }, name !== undefined ? name : url), /*#__PURE__*/React.createElement(_Close.default, {
            onClick: this.handleDelete,
            className: "close"
          })), percent !== undefined && /*#__PURE__*/React.createElement("div", {
            className: "progress"
          }, /*#__PURE__*/React.createElement("div", {
            className: "bar",
            style: {
              width: "".concat(percent, "%")
            }
          })));
        },
        drag: function drag() {
          return Config.list.apply(this, []);
        }
      };
      return Config[type].apply(this, []);
    }
  }]);
  return Preview;
}(React.Component), _class3.defaultProps = {
  type: 'list'
}, _class3), ((0, _applyDecoratedDescriptor2.default)(_class2.prototype, "watchValue", [_dec], Object.getOwnPropertyDescriptor(_class2.prototype, "watchValue"), _class2.prototype)), _class2)) || _class);
/**
 *
 * @constructor
 */

var _default = Preview;
exports.default = _default;