/**
 * 获取错误
 * @param url
 * @param option
 * @param xhr
 */
import { ObjectType } from "../../libs/types";
export interface ProgressEvent<T extends EventTarget = EventTarget> extends Event {
    readonly lengthComputable: boolean;
    readonly loaded: number;
    readonly target: T | null;
    readonly total: number;
    percent: number;
}
interface UploadOptions {
    url: string;
    onProgress: (e: ProgressEvent) => void;
    data: ObjectType;
    withCredentials: boolean;
    headers: ObjectType;
    timeout?: number;
}
/**
 * 上传文件的方法
 */
export default function upload(option: UploadOptions): Promise<XMLHttpRequest>;
export {};
