import autoBind from '../../libs/autoBind';
import { forwardRef } from '../../libs/ref';
import { createFormElement } from '../../libs/createFormElement';
import { appendPrepend } from "../../libs/appendPrepend";
import omit from '../../libs/omit';
import EventTarget from '../../libs/event';
import warning from '../../libs/warning';
import loop from "../../libs/loop";
import throttle from "../../libs/throttle";
import debounce from "../../libs/debounce";
import domresize from "../../libs/domresize";
import Portal from "../portal/Portal";
import { JSXToText } from "../../libs/utils/renderToString";
import * as validator from "../../libs/utils/validator";
declare const _default: {
    decorators: {
        autoBind: typeof autoBind;
        throttle: typeof throttle;
        debounce: typeof debounce;
        forwardRef: typeof forwardRef;
        createFormElement: typeof createFormElement;
        loop: typeof loop;
        appendPrepend: typeof appendPrepend;
    };
    EventTarget: typeof EventTarget;
    omit: typeof omit;
    warning: typeof warning;
    validator: typeof validator;
    JSXToText: typeof JSXToText;
    Portal: typeof Portal;
    domresize: typeof domresize;
};
export default _default;
