"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFormElement = createFormElement;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _FormElement = _interopRequireDefault(require("../package/form/FormElement"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 *创建表单元素
 * ps:要想创建该元素 请提供value 属性 onChange属性 onBlur 属性
 * @param isArray
 */
function createFormElement(isArray) {
  return function (Component) {
    var RenderComponent = Component;

    var ForwardedComponent = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
      return /*#__PURE__*/_react.default.createElement(_FormElement.default, {
        isArray: isArray
      }, /*#__PURE__*/_react.default.createElement(RenderComponent, _objectSpread(_objectSpread({}, props), {}, {
        ref: ref
      }), props.children));
    });

    ForwardedComponent.displayName = RenderComponent.name || RenderComponent.displayName || "FormElement"; //将非React特定的静态信息从子组件复制到父组件，因为高阶组件无法将子组件的非React的静态属性或者方法复制过来，所以使用此方法

    var HS = (0, _hoistNonReactStatics.default)(ForwardedComponent, RenderComponent);
    return HS;
  };
}