import * as React from 'react';
interface RenderToStringOptions {
    /**返回带有tagName标签**/
    widthTag?: boolean;
    /**遇到div等元素就不继续渲染**/
    endFirstNativeTag?: boolean;
    /**该参数不应该传入 该参数只用于endFirstNativeTag 为true的时候 会修改这个option的firstTag  **/
    firstTag?: any;
}
/**
 * 将抽象语法树转成text
 * @param element
 * @constructor
 */
export declare function JSXToText(element: React.ReactNode): string;
/**
 *将ReactElement 转成string
 * @param element
 * @param options
 */
export default function renderToString(element?: any, options?: RenderToStringOptions): any;
/**
 *组件层面的转成字符串
 */
export declare function toComponentString(ast: React.ReactNode): string;
export {};
