"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _input = _interopRequireDefault(require("../input"));

var _CascadePanel = _interopRequireDefault(require("./CascadePanel"));

var _watch = _interopRequireDefault(require("../../libs/watch"));

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _FormElement = require("../form/FormElement");

var _Down = _interopRequireDefault(require("net-design-icons/lib/icons/Down"));

var _excluded = ["className", "style", "size", "placeholder", "separator", "dataSource", "expandTrigger", "useCustomScrollBar", "changeOnSelect", "offset", "getContainer", "placement", "onLoadData"];

var _dec, _dec2, _class, _class2, _class3;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Cascade = (_dec = (0, _FormElement.createFormElement)(true), _dec2 = (0, _watch.default)('value'), _dec(_class = (0, _autoBind.default)(_class = (_class2 = (_class3 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Cascade, _React$Component);

  var _super = _createSuper(Cascade);

  function Cascade() {
    var _this;

    (0, _classCallCheck2.default)(this, Cascade);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      value: [],
      visible: false
    };
    _this.ref = /*#__PURE__*/React.createRef();
    _this.el = /*#__PURE__*/React.createRef();
    return _this;
  }

  (0, _createClass2.default)(Cascade, [{
    key: "watchValue",
    value:
    /**
     *
     */
    function watchValue() {
      return null;
    }
    /***
     * 处理打开或者关闭
     */

  }, {
    key: "handleOpenClose",
    value: function handleOpenClose(visible) {
      this.setState({
        visible: visible
      });
    }
    /**
     * 处理改变
     * @param data
     * @param e
     */

  }, {
    key: "handleChange",
    value: function handleChange(data, e) {
      var onChange = this.props.onChange;
      this.setState({
        value: data
      });
      onChange && onChange(data, e);
    }
    /**
     *
     */

  }, {
    key: "handleChooseEnd",
    value: function handleChooseEnd() {
      this.el.current.emitClose();
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          style = _this$props.style,
          size = _this$props.size,
          placeholder = _this$props.placeholder,
          separator = _this$props.separator,
          dataSource = _this$props.dataSource,
          expandTrigger = _this$props.expandTrigger,
          useCustomScrollBar = _this$props.useCustomScrollBar,
          changeOnSelect = _this$props.changeOnSelect,
          offset = _this$props.offset,
          getContainer = _this$props.getContainer,
          placement = _this$props.placement,
          onLoadData = _this$props.onLoadData,
          rest = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var value = this.state.value;
      var visible = this.state.visible;
      var classes = (0, _classnames.default)(className, 'rd-cascade');
      var otherProps = (0, _omit.default)(rest, ['value', 'onChange']); //第一次赋值的时候，会传下来空字符串，导致在使用

      if (!Array.isArray(value)) {
        value = [];
      }

      var suffixIcon = /*#__PURE__*/React.createElement(_Down.default, {
        className: (0, _classnames.default)('arrow-down', {
          'arrow-up': visible
        })
      });
      return /*#__PURE__*/React.createElement(_dropdown.default, {
        disabled: rest.disabled,
        ref: this.el,
        size: size,
        offset: offset,
        popperWidthSameWithChildren: false,
        clickPopperHidden: false,
        clickTriggerRevert: true,
        onOpen: function onOpen() {
          return _this2.handleOpenClose(true);
        },
        onClose: function onClose() {
          return _this2.handleOpenClose(false);
        },
        getContainer: getContainer,
        placement: placement,
        overlay: /*#__PURE__*/React.createElement(_CascadePanel.default, {
          size: size,
          useCustomScrollBar: useCustomScrollBar,
          value: value,
          expandTrigger: expandTrigger,
          changeOnSelect: changeOnSelect,
          options: dataSource,
          onLoadData: onLoadData,
          onChange: this.handleChange,
          onChooseEnd: this.handleChooseEnd
        })
      }, /*#__PURE__*/React.createElement(_input.default, (0, _extends2.default)({
        ref: this.ref,
        readOnly: true,
        unselectable: "on",
        placeholder: placeholder,
        value: value.join(separator),
        className: classes,
        style: _objectSpread({}, style),
        suffix: suffixIcon
      }, otherProps)));
    }
  }]);
  return Cascade;
}(React.Component), _class3.defaultProps = {
  dataSource: [],
  changeOnSelect: true,
  separator: ' / ',
  useCustomScrollBar: false,
  size: 'medium',
  offset: [-1, 0]
}, _class3), ((0, _applyDecoratedDescriptor2.default)(_class2.prototype, "watchValue", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "watchValue"), _class2.prototype)), _class2)) || _class) || _class);
exports.default = Cascade;