import * as React from 'react';
import { CheckProps, CheckboxValueType } from '../radio/interface';
interface CheckboxGroupProps extends CheckProps {
    value?: Array<CheckboxValueType>;
}
interface CheckboxGroupState {
    options?: Array<CheckboxValueType>;
    _prevProps?: CheckboxGroupProps;
}
export default class CheckboxGroup extends React.Component<CheckboxGroupProps, CheckboxGroupState> {
    /**
     * 构造函数
     * @param props
     */
    constructor(props: CheckboxGroupProps);
    static defaultProps: {
        size: string;
    };
    /**
   * 更新父级
   * @param nextProps
   * @param prevState
   */
    static getDerivedStateFromProps(nextProps: CheckboxGroupProps, prevState: CheckboxGroupState): CheckboxGroupState;
    /**
     * group上点击事件
     * @param value
     * @param checked
     */
    onChange(value: CheckboxValueType, e?: React.ChangeEvent<HTMLInputElement>): void;
    /**
     *
     */
    render(): React.ReactNode;
}
export {};
