"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _util = require("../../libs/utils/util");

var _CollapseContext = _interopRequireDefault(require("./CollapseContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _types = require("../../libs/types");

var _Down = _interopRequireDefault(require("net-design-icons/lib/icons/Down"));

var _Right = _interopRequireDefault(require("net-design-icons/lib/icons/Right"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var IconPosition = (0, _types.tuple)('left', 'right');
var CollapseType = (0, _types.tuple)('bordered', 'ghost');

var Collapse = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Collapse, _React$Component);

  var _super = _createSuper(Collapse);

  /** */
  function Collapse(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Collapse);
    _this = _super.call(this, props);
    var openKeys = props.defaultOpenKeys || [];

    if ('openKeys' in props) {
      openKeys = props.openKeys || [];
    }

    _this.state = {
      openKeys: openKeys
    };
    return _this;
  }
  /**
   * 根据上级传下的openKeys改变当前菜单的展开效果
   * @param nextProps
   */


  (0, _createClass2.default)(Collapse, [{
    key: "expandIcon",
    value:
    /**
     * 默认展开图标
     * @param isExpand
     */
    function expandIcon(isExpand) {
      var expandIcon = this.props.expandIcon;
      var classString = (0, _util.getPrefixCls)('collapse-arrow');

      if (expandIcon) {
        var child = expandIcon(isExpand);

        if ((0, _typeof2.default)(child) !== 'object') {
          return /*#__PURE__*/React.createElement("span", {
            className: classString
          }, child);
        } else {
          return /*#__PURE__*/React.cloneElement(child, {
            className: classString
          });
        }
      } else {
        return isExpand ? /*#__PURE__*/React.createElement(_Down.default, {
          className: classString
        }) : /*#__PURE__*/React.createElement(_Right.default, {
          className: classString
        });
      }
    }
    /**点击Panel的回调方法 */

  }, {
    key: "handlePanel",
    value: function handlePanel(params) {
      var openKeys = this.state.openKeys;
      var index = params.index; //自己维护openKeys
      // if ('openKeys' in this.props) {
      //     this.props.onChange && this.props.onChange({
      //         ...params,
      //         openKeys,
      //     });
      // } else {

      var customOpenKeys = (0, _toConsumableArray2.default)(openKeys);
      var idIndex = customOpenKeys.findIndex(function (item) {
        return item === index;
      });
      var openUnique = this.props.openUnique;

      if (openUnique) {
        customOpenKeys = idIndex === -1 ? [index] : [];
      } else {
        //-1 表示当前为展开操作
        idIndex === -1 ? customOpenKeys.push(index) : customOpenKeys.splice(idIndex, 1);
      }

      this.setState({
        openKeys: (0, _toConsumableArray2.default)(customOpenKeys)
      });
      this.props.onChange && this.props.onChange(_objectSpread(_objectSpread({}, params), {}, {
        openKeys: customOpenKeys
      })); //}
    }
    /** */

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          customizePrefixCls = _this$props.prefixCls,
          className = _this$props.className,
          collapseType = _this$props.collapseType,
          style = _this$props.style,
          expandIconPosition = _this$props.expandIconPosition,
          openUnique = _this$props.openUnique,
          children = _this$props.children;
      var _this$state$openKeys = this.state.openKeys,
          openKeys = _this$state$openKeys === void 0 ? [] : _this$state$openKeys;
      var prefixCls = (0, _util.getPrefixCls)('collapse', customizePrefixCls);
      var classString = (0, _classnames.default)(prefixCls, "is-".concat(collapseType), "".concat(prefixCls, "--icon-position-").concat(expandIconPosition), className);

      var collapseStyle = _objectSpread({}, style);

      if (openUnique && openKeys.length > 1) {
        (0, _warning.default)(false, 'Collapse', 'openUnique is true, the length of openKeys or defaultOpenKeys is more than 1');
        openKeys.splice(1);
      }

      var contextVal = {
        openKeys: openKeys,
        expandIcon: this.expandIcon,
        handlePanel: this.handlePanel
      };
      return /*#__PURE__*/React.createElement(_CollapseContext.default.Provider, {
        value: contextVal
      }, /*#__PURE__*/React.createElement("div", {
        className: classString,
        style: collapseStyle
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      //自己维护openKeys
      if ('openKeys' in nextProps) {
        return {
          openKeys: nextProps.openKeys
        };
      }

      return {};
    }
  }]);
  return Collapse;
}(React.Component), _class2.defaultProps = {
  openUnique: true,
  collapseType: 'bordered',
  expandIconPosition: 'left'
}, _class2.Panel = void 0, _class2)) || _class;

exports.default = Collapse;