import * as React from 'react';
import { CollapseContextProps } from './CollapseContext';
export interface CollapsePanelProps {
    /**唯一标志，必填 */
    index: string | number;
    /**标题 */
    header?: React.ReactNode;
    /**是否允许展开或者收起，默认false */
    disabled?: boolean;
    /**是否显示展开或者收起的图标，默认true */
    showArrows?: boolean;
    style?: React.CSSProperties;
    className?: string;
    prefixCls?: string;
}
export default class CollapsePanel extends React.Component<CollapsePanelProps & CollapseContextProps> {
    static defaultProps: Partial<CollapsePanelProps>;
    headerRef: HTMLElement;
    /**生成DOM */
    renderCollapsePanel(context: CollapseContextProps): React.ReactNode;
    /**
     *
     */
    render(): React.ReactNode;
}
