"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _constants = require("./constants");

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Time = _interopRequireDefault(require("net-design-icons/lib/icons/Time"));

var _ClosePlane = _interopRequireDefault(require("net-design-icons/lib/icons/ClosePlane"));

var _Calendar = _interopRequireDefault(require("net-design-icons/lib/icons/Calendar"));

var _FormContext = require("../form/FormContext");

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * data数据是否合法
 * @param value 
 * @returns 
 */
function isValidValue(value) {
  if (value instanceof Date) {
    return true;
  }

  if (Array.isArray(value) && value.length !== 0 && value[0] instanceof Date) {
    return true;
  }

  return false;
}

var BasePicker = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(BasePicker, _React$Component);

  var _super = _createSuper(BasePicker);

  function BasePicker() {
    var _this;

    (0, _classCallCheck2.default)(this, BasePicker);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.type = void 0;
    _this.dropdown = void 0;
    return _this;
  }

  (0, _createClass2.default)(BasePicker, [{
    key: "handleChange",
    value:
    /**默认改变回调 */
    function handleChange() {
      return undefined;
    }
    /** 展开显示面板默认值为null*/

  }, {
    key: "pickerPanel",
    value: function pickerPanel() {
      return null;
    }
    /** input渲染 */

  }, {
    key: "inputRender",
    value: function inputRender(args) {
      return /*#__PURE__*/React.createElement("span", null);
    }
    /**
     * 默认props值
     */

  }, {
    key: "componentDidMount",
    value:
    /**
     *
     */
    function componentDidMount() {
      /**
      * value为Date|Date[]
      * @returns Date| Date[] 转换后的value为Date| Date[]类型
      */
      var value = this.props.value;
      var newProps = this.propsToState(value);
      this.setState(_objectSpread({}, newProps));
    }
    /**
     * 更新
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var value = this.props.value;
      var newProps = this.propsToState(value);
      /**如果props的value值改变，需要更新value和text值 */

      if (prevProps.value !== value) {
        this.setState(_objectSpread({}, newProps));
      }
    }
    /**
     * 是否为date格式
     */

  }, {
    key: "isDateFormat",
    value: function isDateFormat() {
      var value = this.props.value;
      return value instanceof Date;
    }
    /**关闭下拉框 */

  }, {
    key: "closeDropDown",
    value: function closeDropDown(isKeepPannel) {
      if (!isKeepPannel && this.dropdown) {
        /**手动关闭弹框 */
        this.dropdown.emitClose();
      }
    }
    /**
     * 用于展开面板调用
     *
     * @param value: Date|Date[]|null
     * @param isKeepPannel: boolean = false 是否关闭下拉框
     */

  }, {
    key: "handlePicker",
    value: function handlePicker(value, isKeepPannel) {
      isKeepPannel = isKeepPannel || false;
      var okIcon = this.props.okIcon;

      if ((this.type === 'time' || this.type === 'timerange') && okIcon && isKeepPannel) {
        return this.setState({
          value: value
        });
      }

      var text = this.dateToStr(value);
      this.setState({
        value: value,
        text: text
      });
      this.closeDropDown(isKeepPannel);
      var onPick = this.props.onPick;
      /**返回对应格式 */

      /**值改变，才执onChange回调，this.context.form为了执行表单回调 */

      onPick && onPick(value, text);
      this.context.form && this.context.form.onFieldChange();
    }
    /**
     * date转成string，需要的格式
     * @param date Date
     */

  }, {
    key: "dateToStr",
    value: function dateToStr(date) {
      if (!isValidValue(date)) {
        return '';
      }

      var _ref = _constants.TYPE_VALUE_RESOLVER_MAP[this.type] || _constants.TYPE_VALUE_RESOLVER_MAP['default'],
          formatter = _ref.formatter;

      return formatter(date, this.getFormat());
    }
    /**
     * string转成date格式
     * @param str
     */

  }, {
    key: "parseDate",
    value: function parseDate(str) {
      if (!str) {
        return null;
      }

      var type = this.type;

      var _ref2 = _constants.TYPE_VALUE_RESOLVER_MAP[type] || _constants.TYPE_VALUE_RESOLVER_MAP['default'],
          parser = _ref2.parser;

      return parser(str, this.getFormat());
    }
    /**
     * 获取面板格式化string
     */

  }, {
    key: "getFormat",
    value: function getFormat() {
      var _this$props = this.props,
          showTime = _this$props.showTime,
          format = _this$props.format;
      var defaultFormat = _constants.DEFAULT_FORMATS[this.type];
      /**显示时间时，格式默认为 yyyy-MM-dd hh:mm:ss */

      if (showTime) {
        return format || "".concat(defaultFormat, " ").concat(_constants.DEFAULT_FORMATS['time']);
      }

      return format || _constants.DEFAULT_FORMATS[this.type];
    }
    /**
     * @param value Date|Date[]
     */

  }, {
    key: "propsToState",
    value: function propsToState(value) {
      var state = _objectSpread({}, this.state);
      /*判断value合法，将value转成string ，获取到text ===>  text为显示在input的内容 */


      state.text = this.dateToStr(value);
      state.value = value;
      return state;
    }
    /**
     * input聚焦事件
     */

  }, {
    key: "handleFocus",
    value: function handleFocus() {
      var onFocus = this.props.onFocus;
      onFocus && onFocus();
    }
    /**
     * input失去焦点事件
     */

  }, {
    key: "handleBlur",
    value: function handleBlur() {
      /**在可输入情况下，失去焦点验证输入日期是否合法 */
      var _this$props2 = this.props,
          readonly = _this$props2.readonly,
          onBlur = _this$props2.onBlur;

      if (!readonly) {
        var text = this.state.text;
        this.setState(_objectSpread({}, this.propsToState(this.parseDate(text))));
      }

      onBlur && onBlur();
    }
    /**
     * 键盘处理，如果为tab，收起面板
     * @param evt
     */

  }, {
    key: "handleKeydown",
    value: function handleKeydown(evt) {
      var keyCode = evt.keyCode; // tab

      if (keyCode === 9 || keyCode === 27) {
        /**手动关闭弹框 */
        this.dropdown && this.dropdown.emitClose();
        evt.stopPropagation();
      }
    }
    /**
     * 验证数据是否合法
     * @param date Date
     */

  }, {
    key: "isDateValid",
    value: function isDateValid(date) {
      return date && isValidValue(date);
    }
    /**
     * input输入框检测数据是否合法
     * @param value string
     * return boolean
     */

  }, {
    key: "isInputValid",
    value: function isInputValid(value) {
      var parseable = this.parseDate(value);

      if (!parseable) {
        return false;
      }

      var isdatevalid = this.isDateValid(parseable);

      if (!isdatevalid) {
        return false;
      }

      return true;
    }
    /**
     * 点击icon图标 清除input数据 只读和禁用不能清除数据
     */

  }, {
    key: "handleClickIcon",
    value: function handleClickIcon() {
      var _this$props3 = this.props,
          readonly = _this$props3.readonly,
          disabled = _this$props3.disabled;
      var text = this.state.text;

      if (readonly || disabled) {
        return;
      }

      if (text) {
        this.setState({
          text: null,
          value: null,
          isShowClose: false
        });
        var onPick = this.props.onPick;
        onPick && onPick(null, null);
        this.context.form && this.context.form.onFieldChange();
      }
    }
    /**
     * date-picker渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          readonly = _this$props4.readonly,
          className = _this$props4.className,
          suffixIcon = _this$props4.suffixIcon,
          dropDownProps = _this$props4.dropDownProps,
          inputProps = _this$props4.inputProps,
          clearIcon = _this$props4.clearIcon,
          icon = _this$props4.icon,
          disabled = _this$props4.disabled,
          size = _this$props4.size,
          style = _this$props4.style;
      var _this$state = this.state,
          isShowClose = _this$state.isShowClose,
          text = _this$state.text;
      /**
       * icon图标节点获取
       */

      var createIconSlot = function createIconSlot() {
        if (icon) {
          var dom = null;

          if (isShowClose) {
            dom = clearIcon || /*#__PURE__*/React.createElement(_ClosePlane.default, args);
          } else {
            dom = suffixIcon || (_this2.type.includes('time') ? /*#__PURE__*/React.createElement(_Time.default, args) : /*#__PURE__*/React.createElement(_Calendar.default, args));
          }

          return {
            children: dom,
            onClick: _this2.handleClickIcon,
            onMouseEnter: function onMouseEnter() {
              if (readonly || disabled) {
                return;
              }

              if (text) {
                _this2.setState({
                  isShowClose: true
                });
              }
            },
            onMouseLeave: function onMouseLeave() {
              _this2.setState({
                isShowClose: false
              });
            }
          };
        } else {
          return null;
        }
      };
      /**
       * 创建展开面板节点，关闭时销毁面板信息
       */


      var createPickerPanel = function createPickerPanel() {
        /**如果禁止修改，则不渲染下拉框 */
        if (disabled) {
          return null;
        }

        var pickerPanel = _this2.pickerPanel();

        return pickerPanel;
      };

      var args = _objectSpread(_objectSpread({}, inputProps), {}, {
        style: _objectSpread({}, style),
        className: (0, _classnames.default)(className, 'rd-date', "rd-date--".concat(this.type), inputProps.className),
        readOnly: readonly,
        disabled: disabled,
        type: "text",
        suffix: createIconSlot(),
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        onKeyDown: this.handleKeydown,
        onChange: this.handleChange
      });
      /**设置下拉框默认偏移量 */


      dropDownProps.offset = dropDownProps.offset || [0, 0];
      return /*#__PURE__*/React.createElement(_FormContext.SizeContext.Consumer, null, function () {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            contextSize = _ref3.size;

        var _size = size || contextSize || 'medium';

        return /*#__PURE__*/React.createElement(_dropdown.default, (0, _extends2.default)({}, dropDownProps, {
          overlay: createPickerPanel(),
          ref: function ref(_ref4) {
            return _this2.dropdown = _ref4;
          }
        }), _this2.inputRender(_objectSpread({
          size: _size
        }, args)));
      });
    }
  }], [{
    key: "toDate",
    value:
    /**
     * 提供外部方法，将string转成Date格式传入组件
     * @param str 
     * @param format 
     * @returns 
     */
    function toDate(text, format) {
      return text && (0, _constants.DATE_PARSER)(text, format);
    }
    /**
     * 
     * @param params 
     * @returns 
     */

  }, {
    key: "toString",
    value: function toString(date, format) {
      if (date instanceof Date) {
        return (0, _constants.DATE_FORMATTER)(date, format);
      }
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        /**默认显示input后缀图标 */
        icon: true,

        /**默认只读 */
        readonly: true,

        /**下拉框属性集合 */
        dropDownProps: {},

        /**输入框属性集合 */
        inputProps: {},
        value: null
      };
    }
  }]);
  return BasePicker;
}(React.Component)) || _class;

exports.default = BasePicker;