"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _BasePicker2 = _interopRequireDefault(require("./BasePicker"));

var _TimePanel = _interopRequireDefault(require("./panel/TimePanel"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _input = _interopRequireDefault(require("../input"));

var _dec, _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TimePicker = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = /*#__PURE__*/function (_BasePicker) {
  (0, _inherits2.default)(TimePicker, _BasePicker);

  var _super = _createSuper(TimePicker);

  /**
   *
   * @param props 构造函数
   */
  function TimePicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TimePicker);
    _this = _super.call(this, props);
    _this.state = {};
    _this.type = 'time';
    _this.state = {
      text: ''
    };
    return _this;
  }
  /**
   * 时间选择器面板
   * @param state
   * @param props
   */


  (0, _createClass2.default)(TimePicker, [{
    key: "pickerPanel",
    value: function pickerPanel() {
      var _this2 = this;

      var value = this.state.value;
      var _this$props = this.props,
          okIcon = _this$props.okIcon,
          showTime = _this$props.showTime;
      return /*#__PURE__*/React.createElement(_TimePanel.default, (0, _extends2.default)({}, this.props, {
        currentDate: value,
        showTopText: showTime,
        showTime: okIcon || showTime,
        onPicked: function onPicked(value, isKeepPannel) {
          return _this2.handlePicker(value, isKeepPannel);
        }
      }));
    }
    /**
    * input渲染
    * @returns 
    */

  }, {
    key: "inputRender",
    value: function inputRender(args) {
      var placeholder = this.props.placeholder;
      var text = this.state.text;
      return /*#__PURE__*/React.createElement(_input.default, (0, _extends2.default)({}, args, {
        placeholder: placeholder,
        value: text ? text : ''
      }));
    }
    /**
    * input值改变时的回调
    * params为input的e或者Interval的value值
    */

  }, {
    key: "handleChange",
    value: function handleChange(e) {
      var value = e.target.value;
      this.setState({
        text: value
      });
      var onChange = this.props.onChange;
      onChange && onChange(value, e, 0);
      this.context.form && this.context.form.onFieldChange();
    }
  }], [{
    key: "defaultProps",
    get:
    /**
     * 默认props数据
     */
    function get() {
      return Object.assign({}, _BasePicker2.default.defaultProps);
    }
  }]);
  return TimePicker;
}(_BasePicker2.default)) || _class) || _class);
exports.default = TimePicker;