"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _utils = require("../utils");

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../../libs/autoBind"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TimeSpinner = (0, _autoBind.default)(_class = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TimeSpinner, _React$Component);

  var _super = _createSuper(TimeSpinner);

  /**
   * 构造函数
   * @param props
   */
  function TimeSpinner(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TimeSpinner);
    _this = _super.call(this, props);
    _this.hours = void 0;
    _this.minutes = void 0;
    _this.seconds = void 0;
    _this.state = _objectSpread({
      hours: props.hours,
      minutes: props.minutes,
      seconds: props.seconds
    }, _this.propsToState());
    return _this;
  }
  /**
   * 第一次渲染快速跳至时间刻度，不用显示动画效果，动画时间缩短为10
   */


  (0, _createClass2.default)(TimeSpinner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.ajustScrollTop(this.state, 10);
    }
    /**
     * 对象比较
     * @param a 
     * @param b 
     */

  }, {
    key: "objComparise",
    value: function objComparise(a, b) {
      return JSON.stringify(a) === JSON.stringify(b);
    }
    /**
        * 更新完成后滚动时间刻度
        */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      var _this$props = this.props,
          hours = _this$props.hours,
          minutes = _this$props.minutes,
          seconds = _this$props.seconds,
          range = _this$props.range;
      var lists = this.propsToState();
      this.objComparise(prevState.hoursList, lists.hoursList);
      this.objComparise(prevState.secondsList, lists.secondsList);

      if (prevProps.range !== range || prevProps.hours !== hours || prevProps.minutes !== minutes || prevProps.seconds !== seconds) {
        this.setState(_objectSpread(_objectSpread({}, lists), {}, {
          hours: hours,
          minutes: minutes,
          seconds: seconds
        }), function () {
          _this2.ajustScrollTop(_this2.state);
        });
      }
    }
    /**
     * 更新render
     * @returns any
     */

  }, {
    key: "propsToState",
    value: function propsToState() {
      var _this$props2 = this.props,
          range = _this$props2.range,
          hours = _this$props2.hours,
          minutes = _this$props2.minutes;
      return {
        hoursList: (0, _utils.getRangeHours)(range),
        minutesList: (0, _utils.getRangeMinutes)(range, hours),
        secondsList: (0, _utils.getRangeSeconds)(range, hours, minutes)
      };
    }
    /**
     * 计算滚动的距离
     * @param value number 处于第几个li 32为每个li的高度
     * @returns number
     */

  }, {
    key: "calcScrollTop",
    value: function calcScrollTop(value) {
      var dom = this.hours || this.minutes || this.seconds;
      var height = dom && dom.childNodes[0].clientHeight;
      return Math.max(0, value * height);
    }
    /**
     * 时分秒改变的函数
     * @param type type: hours, minutes, seconds
     * @param value
     * @param disabled
     */

  }, {
    key: "handleChange",
    value: function handleChange(type, value, disabled) {
      if (disabled) {
        return;
      }

      var changed = {};
      changed[type] = value;
      var onChanged = this.props.onChanged;
      onChanged && onChanged(changed);
    }
    /**
     * 时分秒滚动执行函数
     * @param param0
     * @param duration
     */

  }, {
    key: "ajustScrollTop",
    value: function ajustScrollTop(_ref, duration) {
      var hours = _ref.hours,
          minutes = _ref.minutes,
          seconds = _ref.seconds;
      var d = duration || 120;
      var _this$props3 = this.props,
          hoursStep = _this$props3.hoursStep,
          minutesStep = _this$props3.minutesStep,
          secondsStep = _this$props3.secondsStep;

      if (hours != null) {
        (0, _utils.scrollTo)(this.hours, this.calcScrollTop(hours / hoursStep), d);
      }

      if (minutes != null) {
        (0, _utils.scrollTo)(this.minutes, this.calcScrollTop(minutes / minutesStep), d);
      }

      if (this.seconds && seconds != null) {
        (0, _utils.scrollTo)(this.seconds, this.calcScrollTop(seconds / secondsStep), d);
      }
    }
    /**
     * 时间选择渲染
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$state = this.state,
          hoursList = _this$state.hoursList,
          minutesList = _this$state.minutesList,
          secondsList = _this$state.secondsList,
          hours = _this$state.hours,
          minutes = _this$state.minutes,
          seconds = _this$state.seconds;
      var _this$props4 = this.props,
          showSeconds = _this$props4.showSeconds,
          fillZero = _this$props4.fillZero,
          scrollClassName = _this$props4.scrollClassName,
          hoursStep = _this$props4.hoursStep,
          minutesStep = _this$props4.minutesStep,
          secondsStep = _this$props4.secondsStep;
      /**是否填充0 */

      var isFillZero = function isFillZero(i) {
        if (fillZero && i < 10) {
          return "0".concat(i);
        }

        return i;
      };

      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-time-spinner', {
          'has-seconds': showSeconds
        })
      }, /*#__PURE__*/React.createElement("ul", {
        ref: function ref(_ref2) {
          return _this3.hours = _ref2;
        },
        className: (0, _classnames.default)(scrollClassName, 'rd-time-spinner__wrapper')
      }, hoursList.map(function (enable, hour) {
        if (hour % hoursStep !== 0) {
          return;
        }

        return /*#__PURE__*/React.createElement("li", {
          key: hour,
          onClick: function onClick() {
            return _this3.handleChange('hours', hour, !enable);
          },
          className: (0, _classnames.default)('rd-time-spinner__item', {
            active: hour === hours,
            disabled: !enable
          })
        }, isFillZero(hour));
      })), /*#__PURE__*/React.createElement("ul", {
        ref: function ref(_ref3) {
          return _this3.minutes = _ref3;
        },
        className: (0, _classnames.default)(scrollClassName, 'rd-time-spinner__wrapper')
      }, minutesList.map(function (enable, minute) {
        if (minute % minutesStep !== 0) {
          return;
        }

        return /*#__PURE__*/React.createElement("li", {
          key: minute,
          onClick: function onClick() {
            return _this3.handleChange('minutes', minute, !enable);
          },
          className: (0, _classnames.default)('rd-time-spinner__item', {
            active: minute === minutes,
            disabled: !enable
          })
        }, isFillZero(minute));
      })), showSeconds && /*#__PURE__*/React.createElement("ul", {
        ref: function ref(_ref4) {
          return _this3.seconds = _ref4;
        },
        className: (0, _classnames.default)(scrollClassName, 'rd-time-spinner__wrapper')
      }, secondsList.map(function (enable, second) {
        if (second % secondsStep !== 0) {
          return;
        }

        return /*#__PURE__*/React.createElement("li", {
          key: second,
          onClick: function onClick() {
            return _this3.handleChange('seconds', second, !enable);
          },
          className: (0, _classnames.default)('rd-time-spinner__item', {
            active: second === seconds,
            disabled: !enable
          })
        }, isFillZero(second));
      })));
    }
  }], [{
    key: "defaultProps",
    get:
    /**
     * 默认props值
     */
    function get() {
      return {
        hours: 0,
        minutes: 0,
        seconds: 0,
        hoursStep: 1,
        minutesStep: 1,
        secondsStep: 1,
        fillZero: true
      };
    }
  }]);
  return TimeSpinner;
}(React.Component)) || _class;

exports.default = TimeSpinner;