import * as React from 'react';
declare const RowAligns: ["top", "middle", "bottom"];
declare const RowJustify: ["start", "end", "center", "space-around", "space-between"];
export interface RowProps extends React.HTMLAttributes<HTMLDivElement> {
    gutter?: number | [number, number];
    type?: string;
    align?: typeof RowAligns[number];
    justify?: typeof RowJustify[number];
    prefixCls?: string;
    direction?: string;
}
export default class Row extends React.Component<RowProps> {
    static defaultProps: {
        gutter: number;
    };
    /** */
    getGutter(): [number, number];
    renderRow: () => React.ReactNode;
    /** */
    render(): React.ReactNode;
}
export {};
