import * as React from 'react';
import { InputBaseProps, Slot } from "./Input";
interface AppendPrependProps {
    [key: string]: any;
    component?: any;
}
declare type FunctionChildren = (classes: string) => React.ReactElement;
interface PrefixesSuffixesProps extends InputBaseProps {
    isClearVisible?: boolean;
    onClear?: (e: React.MouseEvent) => void;
    renderLimitText?: string;
    children: React.ReactElement | FunctionChildren;
    getRef?: (ref: HTMLDivElement) => void;
}
export declare class PrefixesSuffixes extends React.PureComponent<PrefixesSuffixesProps> {
    state: {
        isClearVisible: false;
    };
    static contextType: React.Context<any>;
    /**
     *得到prefix或者suffix
     */
    getFix(): {
        suffixes: Array<Slot>;
        prefixes: Array<Slot>;
    };
    /**
     * 处理清除
     * @param e
     */
    private handleClear;
    /**
     * 渲染函数
     */
    render(): React.ReactNode;
}
export default class AppendPrepend<T extends AppendPrependProps> extends React.PureComponent<T> {
    static contextType: React.Context<any>;
    /**
     * 渲染函数
     */
    render(): React.ReactElement;
}
export {};
