import React from 'react';
import { IntervalProps } from "../interval/Interval";
import { Omit } from "../../libs/types";
interface IpProps extends Omit<IntervalProps, 'value' | 'onChange'> {
    separator?: string;
    value?: string;
    onChange?: (value: string, e: React.ChangeEvent<HTMLInputElement>) => void;
}
export default class Ip extends React.PureComponent<IpProps> {
    static defaultProps: {
        separator: string;
        regexp: RegExp[];
    };
    /**
     * 处理改变
     */
    private handleChange;
    /**
     */
    render(): React.ReactElement;
}
export {};
