"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireDefault(require("react"));

var _FormElement = require("../form/FormElement");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Interval = _interopRequireDefault(require("../interval/Interval"));

var _Span = _interopRequireDefault(require("../span/Span"));

var _excluded = ["regexp", "separator", "title", "value"];

var _dec, _class, _class2;

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Ip = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Ip, _React$PureComponent);

  var _super = _createSuper(Ip);

  function Ip() {
    (0, _classCallCheck2.default)(this, Ip);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Ip, [{
    key: "handleChange",
    value:
    /**
     * 处理改变
     */
    function handleChange(value, e) {
      var _this$props = this.props,
          onChange = _this$props.onChange,
          separator = _this$props.separator;

      var _value = value.join(separator);

      onChange && onChange(_value, e);
    }
    /**
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          regexp = _this$props2.regexp,
          separator = _this$props2.separator,
          title = _this$props2.title,
          value = _this$props2.value,
          rest = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);

      var _value = value !== undefined ? function () {
        var res = value.split(separator);
        var length = res.length;

        if (length !== 4) {
          for (var i = 0; i < 4 - length; i++) {
            res.push('');
          }
        }

        return res;
      }() : undefined;

      var main = /*#__PURE__*/_react.default.createElement(_Interval.default, (0, _extends2.default)({}, rest, {
        gapWordLimit: 3,
        value: _value,
        onChange: this.handleChange,
        several: 4,
        regexp: regexp,
        textAlign: "center",
        nextKeyCode: 110
      }));

      if (title === undefined) {
        return main;
      } else {
        return /*#__PURE__*/_react.default.createElement(_Span.default, {
          needWrapper: false,
          title: title
        }, main);
      }
    }
  }]);
  return Ip;
}(_react.default.PureComponent), _class2.defaultProps = {
  separator: '.',
  regexp: [/^([1-9]|[1-9]\d|(1[013456789]\d|12[012345689])|2[0-1]\d|22[0-3])$/, /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/, /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/, /^([0-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/]
}, _class2)) || _class) || _class);
exports.default = Ip;