"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = {
  rd: {
    common: {
      confirm: 'OK',
      cancel: 'Cancel',
      confirmTitle: 'Are you sure to delete',
      test: 'Test'
    },
    message: {
      know: 'I know',
      placeholder: 'Please enter'
    },
    select: {
      loading: 'Loading',
      noMatch: 'No matching data',
      noData: 'No data',
      placeholder: 'Please select'
    },
    form: {
      propNotValid: 'The incoming prop is not valid'
    },
    pagination: {
      goto: 'Go to {input} page',
      pagesize: '{num} items/page',
      total: 'Total {total} items'
    },
    upload: {
      uploadImg: 'Upload photos',
      clickToUpload: 'Click on file to upload',
      dragToUpload: 'Click or drag the file here to upload',
      dragNotSupported: 'This browser does not support drag upload',
      notSupportedFile: 'This type of file is not supported: (file)',
      notSupported: 'This type of file is not supported',
      supportForExtensions: 'Support extension: {ext}',
      notValidImage: 'Not a valid image file',
      delete: 'Delete',
      preview: 'View pictures',
      continue: 'Continue upload',
      selectFile: 'Select file',
      notSelected: 'No file selected'
    },
    table: {
      emptyText: 'No data temporarily',
      loading: 'Loading',
      clickAscending: 'Click ascending',
      clickDescending: 'Click descending',
      unsort: 'Cancel sorting'
    },
    validator: {
      require: 'cannot be empty',
      ip: 'Please enter a valid IP address',
      ipStart127: 'The IP address cannot start with 127. Enter another IP address again.',
      ip223: 'The IP address cannot start with {start}. It must start with a digit ranging from 1 to 223.',
      mask: 'Please enter a valid subnet mask',
      mac: 'Please enter a valid MAC address',
      byteRange: 'Range: {min}-{max} bytes',
      ssid: 'Please enter a valid SSID',
      ascii: 'Please enter a valid ASCII code character',
      asciiRange: 'Please enter {min}-{max} ASCII code characters',
      hex: 'Please enter a valid hexadecimal number',
      hexRange: 'Please enter {min}-{max} hexadecimal number',
      ssidPwd: 'Please enter 8-63 ASCII characters or 8-64 hexadecimal characters',
      email: 'Please enter the correct email account',
      domain: 'Please enter a valid domain name',
      domainRange: 'Domain name length range: {min}-{max}',
      numRange: 'Range: {min}-{max}',
      portRange: 'Port range: {min}-{max}',
      maxChar: 'You can only enter {max} characters at most',
      url: 'Please enter a valid URL',
      onlyNumber: 'It can only be a number, the first char cannot start with 0',
      serverName: 'Please enter numbers, letters, or special characters: @:-_ + .',
      date: "Please enter a valid date"
    }
  }
};
exports.default = _default;