"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = {
  rd: {
    common: {
      confirm: '确定',
      cancel: '取消',
      confirmTitle: '你确定删除吗',
      test: '测试'
    },
    message: {
      know: '知道了',
      placeholder: '请输入'
    },
    select: {
      loading: '加载中',
      noMatch: '无匹配数据',
      noData: '无数据',
      placeholder: '请选择'
    },
    form: {
      propNotValid: '传入prop不是有效的'
    },
    pagination: {
      goto: '跳至 {input} 页',
      pagesize: '{num} 条/页',
      total: '共 {total} 条'
    },
    upload: {
      uploadImg: '上传照片',
      clickToUpload: '点击文件上传',
      dragToUpload: '点击或将文件拖拽到这里上传',
      dragNotSupported: '该浏览器不支持拖动上传',
      notSupportedFile: '不支持该类型的文件:{file}',
      notSupported: '不支持该类型的文件',
      supportForExtensions: '支持扩展名：{ext}',
      notValidImage: '不是有效的图片文件',
      delete: '删除',
      preview: '查看图片',
      continue: '继续上传',
      selectFile: '选择文件',
      notSelected: '未选择任何文件'
    },
    table: {
      emptyText: '暂无数据',
      loading: '加载中',
      clickAscending: '点击升序',
      clickDescending: '点击降序',
      unsort: '取消排序'
    },
    validator: {
      require: '不能为空',
      ip: '请输入有效的IP地址',
      ipStart127: 'IP地址不能以“127”开头，请重新输入',
      ip223: 'IP地址不能以{start}开头，正确开头值范围：1-223',
      mask: '请输入有效的子网掩码',
      mac: '请输入有效的MAC地址',
      byteRange: '范围：{min} - {max}字节',
      ssid: '请输入有效的SSID',
      ascii: '请输入有效的ASCII码字符',
      asciiRange: '请输入{min} - {max}位ASCII码字符',
      hex: '请输入有效的十六进制数',
      hexRange: '请输入{min} - {max}位十六进制数',
      ssidPwd: '请输入8 - 63位ASCII码字符或8 - 64位十六进制',
      email: '请输入正确的邮箱账号',
      domain: '请输入有效的域名',
      domainRange: '域名长度范围：{min} - {max}',
      numRange: '范围：{min} - {max}',
      portRange: '端口范围：{min} - {max}',
      maxChar: '最多只能输入{max}个字符',
      url: '请输入有效的网址',
      onlyNumber: '只能为数字，首位数不能以0开始',
      serverName: '请输入数字、字母、或特殊字符：@ : - _ + .',
      date: "请输入有效的日期"
    },
    datepicker: {
      now: '此刻',
      today: '今天',
      cancel: '取消',
      clear: '清空',
      confirm: '确定',
      selectDate: '选择日期',
      selectTime: '选择时间',
      startDate: '开始日期',
      startTime: '开始时间',
      endDate: '结束日期',
      endTime: '结束时间',
      year: '{year}年',
      month: '{month}月',
      month1: '1 月',
      month2: '2 月',
      month3: '3 月',
      month4: '4 月',
      month5: '5 月',
      month6: '6 月',
      month7: '7 月',
      month8: '8 月',
      month9: '9 月',
      month10: '10 月',
      month11: '11 月',
      month12: '12 月',
      weeks: {
        sun: '日',
        mon: '一',
        tue: '二',
        wed: '三',
        thu: '四',
        fri: '五',
        sat: '六'
      },
      months: {
        jan: '1月',
        feb: '2月',
        mar: '3月',
        apr: '4月',
        may: '5月',
        jun: '6月',
        jul: '7月',
        aug: '8月',
        sep: '9月',
        oct: '10月',
        nov: '11月',
        dec: '12月'
      }
    }
  }
};
exports.default = _default;