"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _RadioContext = _interopRequireDefault(require("./RadioContext"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RadioGroup = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(RadioGroup, _React$Component);

  var _super = _createSuper(RadioGroup);

  /**
   *
   * @param props
   */
  function RadioGroup(props) {
    var _this;

    (0, _classCallCheck2.default)(this, RadioGroup);
    _this = _super.call(this, props);
    _this.state = {
      value: props.value
    };
    return _this;
  } // 默认大小为medium


  (0, _createClass2.default)(RadioGroup, [{
    key: "onChange",
    value:
    /**
     *
     * @param e
     */
    function onChange(value) {
      var onChange = this.props.onChange;
      onChange && onChange(value);
      this.setState({
        value: value
      });
    }
    /**
     *
     * @param e
     */

  }, {
    key: "onClick",
    value: function onClick(value) {
      var onClick = this.props.onClick;
      onClick && onClick(value);
    }
    /**
     *
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          style = _this$props.style,
          children = _this$props.children,
          size = _this$props.size,
          className = _this$props.className;
      var value = this.state.value;
      return /*#__PURE__*/React.createElement(_RadioContext.default.Provider, {
        value: {
          component: this
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: style,
        className: (0, _classnames.default)(className, 'rd-radio-group')
      }, React.Children.map(children, function (element) {
        if ( /*#__PURE__*/React.isValidElement(element)) {
          return /*#__PURE__*/React.cloneElement(element, Object.assign({}, element.props, {
            // group上事件, 覆盖里面的radio或radioGroup上的props.onChange和onClick事件
            onChange: _this2.onChange,
            onClick: _this2.onClick,
            // 使用group上的大小
            model: value,
            size: size
          }));
        } else {
          return element;
        }
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
    * 更新父级
    * @param nextProps
    * @param prevState
    */
    function getDerivedStateFromProps(nextProps, prevState) {
      var newOptions = nextProps.value;

      if (prevState._prevProps) {
        if (nextProps.value === prevState._prevProps.value) {
          newOptions = prevState.value;
        }
      }

      return {
        _prevProps: nextProps,
        value: newOptions
      };
    }
  }]);
  return RadioGroup;
}(React.Component), _class2.defaultProps = {
  size: 'medium'
}, _class2)) || _class) || _class);
exports.default = RadioGroup;