import { ObjectType } from "../../libs/types";
/** */
export declare function getInnerHeight(el: HTMLElement): number;
/** */
export declare function getInnerWidth(el: HTMLElement): number;
/**
 * 获取内容的高度，在不需要垂直滚动条的时候使用
*/
export declare function getViewHeight(el: HTMLElement): number;
/** */
export declare function getScrollbarWidth(): boolean | number;
/**是否为字符串 */
export declare function isString(maybe: unknown): boolean;
/**返回false */
export declare function returnFalse(): boolean;
/**设置CSS样式到DOM上, 用的时候基本上都是小写，后续注意浏览器兼容 */
export declare function setCss(element: HTMLElement, properties: string | ObjectType): void;
/**获取隐藏元素的高度 */
export declare function getSize(elem: HTMLElement): {
    width: number;
    height: number;
    scrollWidth: number;
    scrollHeight: number;
};
