"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _types = require("../../libs/types");

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _Tag = _interopRequireDefault(require("./Tag"));

var _Input = _interopRequireDefault(require("../input/Input"));

var _AppendPrepend = require("../input/AppendPrepend");

var _appendPrepend = require("../../libs/appendPrepend");

var _FormContext = require("../form/FormContext");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TagTypeTypes = (0, _types.tuple)('success', 'info', 'danger', 'warning');
var TagThemeTypes = (0, _types.tuple)('dark', 'light', 'plain');
var TagGroup = (_dec = (0, _appendPrepend.appendPrepend)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TagGroup, _React$Component);

  var _super = _createSuper(TagGroup);

  function TagGroup() {
    var _this;

    (0, _classCallCheck2.default)(this, TagGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      searchValue: ''
    };
    _this.searchRef = /*#__PURE__*/React.createRef();
    return _this;
  }

  (0, _createClass2.default)(TagGroup, [{
    key: "componentDidUpdate",
    value:
    /**内容更新后 */
    function componentDidUpdate() {
      var _this$props = this.props,
          searchable = _this$props.searchable,
          visible = _this$props.visible;

      if (searchable && visible) {
        this.searchRef.current.focus();
      }
    }
    /**
     * 关闭
     * @param e
     * @param index
     */

  }, {
    key: "handleClose",
    value: function handleClose(e, index) {
      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          value = _this$props2.value;

      var _value = (0, _toConsumableArray2.default)(value);

      _value.splice(index, 1);

      onChange && onChange(_value, e);
    }
    /**
     *将输入框置空
     */

  }, {
    key: "handleClear",
    value: function handleClear(e) {
      var onChange = this.props.onChange;
      onChange && onChange([], e);
    }
    /**搜索 */

  }, {
    key: "handleSearchChange",
    value: function handleSearchChange(e) {
      this.setState({
        searchValue: e.target.value
      }); // 根据搜索搜索出列表内容

      this.props.onSearchOptions(e.target.value);
    }
    /**searchFocusFocus */

  }, {
    key: "handleSearchInput",
    value: function handleSearchInput(type) {
      var visible = this.props.visible;
      visible && this.searchRef.current.focus();

      if (type === 'clear') {
        this.setState({
          searchValue: ''
        });
        this.props.onSearchOptions('');
      }
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$context,
          _this2 = this;

      var _this$props3 = this.props,
          className = _this$props3.className,
          type = _this$props3.type,
          style = _this$props3.style,
          theme = _this$props3.theme,
          name = _this$props3.name,
          readOnly = _this$props3.readOnly,
          disabled = _this$props3.disabled,
          closable = _this$props3.closable,
          value = _this$props3.value,
          onClick = _this$props3.onClick,
          bordered = _this$props3.bordered,
          placeholder = _this$props3.placeholder,
          suffix = _this$props3.suffix,
          prefix = _this$props3.prefix,
          status = _this$props3.status,
          allowClear = _this$props3.allowClear,
          searchable = _this$props3.searchable;
      var searchValue = this.state.searchValue;
      var size = this.props.size || ((_this$context = this.context) === null || _this$context === void 0 ? void 0 : _this$context.size);
      var classes = (0, _classnames.default)('rd-tag-group', className, {
        'is-bordered': bordered,
        'rd-tag-group--success': type === 'success',
        'rd-tag-group--info': type === 'info',
        'rd-tag-group--danger': type === 'danger',
        'rd-tag-group--warning': type === 'warning',
        'rd-tag-group--dark': theme === 'dark',
        'rd-tag-group--light': theme === 'light',
        'rd-tag-group--plain': theme === 'plain',
        'rd-tag-group--large': size === 'large',
        'rd-tag-group--medium': size === 'medium',
        'rd-tag-group--small': size === 'small'
      });
      return /*#__PURE__*/React.createElement(_FormContext.SizeContext.Provider, {
        value: {
          size: size
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread(_objectSpread({}, style), {}, {
          height: 'auto'
        }),
        onClick: onClick
      }, value.length === 0 ? /*#__PURE__*/React.createElement(_Input.default, {
        ref: this.searchRef,
        name: name,
        bordered: false,
        readOnly: searchable ? false : readOnly,
        disabled: disabled,
        placeholder: placeholder,
        className: "rd-tag-group-input",
        suffix: suffix,
        prefix: prefix,
        value: searchValue,
        onChange: this.handleSearchChange
      }) : /*#__PURE__*/React.createElement("input", {
        name: name,
        hidden: true,
        readOnly: true,
        value: JSON.stringify(value),
        style: {
          display: 'none'
        }
      }), value.length !== 0 && /*#__PURE__*/React.createElement(_AppendPrepend.PrefixesSuffixes, {
        className: 'rd-tag-group--flex',
        allowClear: allowClear,
        suffix: suffix,
        prefix: prefix,
        status: status,
        isClearVisible: value.length !== 0,
        onClear: this.handleClear
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          display: 'table-cell',
          width: '100%'
        }
      }, value.map(function (item, index) {
        return /*#__PURE__*/React.createElement(_Tag.default, {
          key: "".concat(index).concat(item),
          size: size,
          theme: theme,
          type: type,
          closable: closable,
          onClose: function onClose(e) {
            return _this2.handleClose(e, index);
          }
        }, (0, _typeof2.default)(item) === 'object' && item !== null ? item.label : item);
      }), searchable && /*#__PURE__*/React.createElement(_Input.default, {
        className: "rd-tag--search-input",
        ref: this.searchRef,
        bordered: false,
        size: size,
        fitSize: true,
        value: searchValue,
        unselectable: "on" //ie readonly 一样会有聚焦的表现形式 所以加上这么一句话
        ,
        onChange: this.handleSearchChange
      })))));
    }
  }]);
  return TagGroup;
}(React.Component), _class2.defaultProps = {
  closable: true,
  bordered: true,
  size: 'medium',
  value: [],
  searchable: false
}, _class2.contextType = _FormContext.SizeContext, _class2)) || _class) || _class);
exports.default = TagGroup;