"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _RightCircleFill = _interopRequireDefault(require("net-design-icons/lib/icons/RightCircleFill"));

var _LeftCircleFill = _interopRequireDefault(require("net-design-icons/lib/icons/LeftCircleFill"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _watch = _interopRequireDefault(require("../../libs/watch"));

var _FormElement = require("../form/FormElement");

var _ScrollBar = _interopRequireDefault(require("../scroll-bar/ScrollBar"));

var _dec, _dec2, _class, _class2, _class3, _dec3, _class4, _class5, _class6;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

/**
 * 将数组1中和arr2中重复的部分去掉
 * 优化速度
 * @param arr1
 * @param arr2
 */
function removeRepeat(arr1, arr2) {
  var res = {};

  for (var i = 0; i < arr1.length; i++) {
    var item = arr1[i];
    res[item.key] = item;
  }

  for (var _i = 0; _i < arr2.length; _i++) {
    var _item = arr2[_i];
    delete res[_item.key];
  }

  return Object.values(res);
}

var Panel = (_dec = (0, _FormElement.createFormElement)(), _dec2 = (0, _watch.default)('value'), _dec(_class = (0, _autoBind.default)(_class = (_class2 = (_class3 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(Panel, _React$PureComponent);

  var _super = _createSuper(Panel);

  function Panel() {
    var _this;

    (0, _classCallCheck2.default)(this, Panel);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      value: [],
      isIndeterminate: true
    };
    return _this;
  }

  (0, _createClass2.default)(Panel, [{
    key: "watchValue",
    value:
    /**
     * 监听value变化
     */
    function watchValue() {
      return null;
    }
    /**
     * 初次渲染
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var defaultChecked = this.props.defaultChecked;
      this.setState({
        value: defaultChecked
      });
    }
    /**
     *单次改变
     */

  }, {
    key: "handleChange",
    value: function handleChange(value) {
      var onChange = this.props.onChange;

      var _value = value.map(function (item) {
        return JSON.parse(item);
      });

      this.setState({
        value: _value
      });
      onChange && onChange(_value);
    }
    /**
     *批量选择
     */

  }, {
    key: "handleAllChange",
    value: function handleAllChange(value, e) {
      var _this$props = this.props,
          options = _this$props.options,
          onChange = _this$props.onChange;
      var checkedOptions = e.target.checked ? options.filter(function (item) {
        return !item.disabled;
      }) : [];
      this.setState({
        value: checkedOptions
      });
      onChange && onChange(checkedOptions);
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var value = this.state.value;
      var _this$props2 = this.props,
          options = _this$props2.options,
          title = _this$props2.title;

      var _option = options.filter(function (item) {
        return !item.disabled;
      });

      var checkAll = value.length === _option.length && _option.length !== 0;
      var isIndeterminate = value.length > 0 && value.length < _option.length;

      var _value = value.map(function (item) {
        return JSON.stringify(item);
      });

      return /*#__PURE__*/React.createElement("div", {
        className: "rd-transfer-panel"
      }, /*#__PURE__*/React.createElement("div", {
        className: "rd-transfer-panel__header"
      }, /*#__PURE__*/React.createElement(_checkbox.default, {
        label: title,
        disabled: _option.length === 0,
        indeterminate: isIndeterminate,
        checked: checkAll,
        onChange: this.handleAllChange
      }), /*#__PURE__*/React.createElement("span", {
        className: "rd-transfer-panel__header-hint"
      }, value.length, "/", _option.length)), /*#__PURE__*/React.createElement(_ScrollBar.default, {
        style: {
          height: 246
        },
        className: "rd-transfer-panel__content"
      }, /*#__PURE__*/React.createElement(_checkbox.default.Group, {
        onChange: this.handleChange,
        value: _value
      }, options.map(function (item) {
        return /*#__PURE__*/React.createElement(_checkbox.default, {
          key: item.key,
          label: item.label,
          disabled: item.disabled,
          value: JSON.stringify(item)
        });
      }))));
    }
  }]);
  return Panel;
}(React.PureComponent), _class3.defaultProps = {
  options: [],
  defaultChecked: []
}, _class3), ((0, _applyDecoratedDescriptor2.default)(_class2.prototype, "watchValue", [_dec2], Object.getOwnPropertyDescriptor(_class2.prototype, "watchValue"), _class2.prototype)), _class2)) || _class) || _class);
var Transfer = (_dec3 = (0, _watch.default)('value'), (0, _autoBind.default)(_class4 = (_class5 = (_class6 = /*#__PURE__*/function (_React$PureComponent2) {
  (0, _inherits2.default)(Transfer, _React$PureComponent2);

  var _super2 = _createSuper(Transfer);

  function Transfer() {
    var _this2;

    (0, _classCallCheck2.default)(this, Transfer);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));
    _this2.state = {
      dataSource: [],
      value: [],
      leftOptions: [],
      leftChecked: [],
      leftDisabled: true,
      rightOptions: [],
      rightChecked: [],
      rightDisabled: true
    };
    return _this2;
  }

  (0, _createClass2.default)(Transfer, [{
    key: "watchValue",
    value:
    /**
     * 监听dataSource变化
     */
    function watchValue() {
      return null;
    }
    /**
     * 点击图标
     */

  }, {
    key: "handleToLeft",
    value: function handleToLeft() {
      var onChange = this.props.onChange;
      var _this$state = this.state,
          rightChecked = _this$state.rightChecked,
          dataSource = _this$state.dataSource,
          value = _this$state.value;

      if (rightChecked.length === 0) {
        return;
      }

      var combinedData = [].concat((0, _toConsumableArray2.default)(dataSource), (0, _toConsumableArray2.default)(rightChecked));
      var rightDataSource = removeRepeat(value, rightChecked);
      this.setState({
        dataSource: combinedData,
        value: rightDataSource,
        leftChecked: [],
        rightChecked: [],
        rightDisabled: true,
        leftDisabled: true
      });
      onChange && onChange(rightDataSource);
    }
    /**
     * 点击图标
     */

  }, {
    key: "handleToRight",
    value: function handleToRight() {
      var onChange = this.props.onChange;
      var _this$state2 = this.state,
          leftChecked = _this$state2.leftChecked,
          dataSource = _this$state2.dataSource,
          value = _this$state2.value;

      if (leftChecked.length === 0) {
        return;
      }

      var _combinedData = removeRepeat(dataSource, leftChecked);

      var rightDataSource = [].concat((0, _toConsumableArray2.default)(leftChecked), (0, _toConsumableArray2.default)(value));
      this.setState({
        dataSource: _combinedData,
        value: rightDataSource,
        leftChecked: [],
        rightChecked: [],
        rightDisabled: true,
        leftDisabled: true
      });
      onChange && onChange(rightDataSource);
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          className = _this$props3.className,
          style = _this$props3.style,
          titles = _this$props3.titles;
      var _this$state3 = this.state,
          leftChecked = _this$state3.leftChecked,
          rightChecked = _this$state3.rightChecked,
          leftDisabled = _this$state3.leftDisabled,
          rightDisabled = _this$state3.rightDisabled,
          dataSource = _this$state3.dataSource,
          value = _this$state3.value;
      var classes = (0, _classnames.default)(className, 'rd-transfer');
      return /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style)
      }, /*#__PURE__*/React.createElement(Panel, {
        title: titles[0],
        options: dataSource,
        value: leftChecked,
        onChange: function onChange(value) {
          _this3.setState({
            leftChecked: value,
            leftDisabled: value.length === 0
          });
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "rd-transfer-actions"
      }, /*#__PURE__*/React.createElement(_LeftCircleFill.default, {
        color: rightDisabled ? '#c0c4cc' : '#D82228',
        className: (0, _classnames.default)({
          'is-disable': rightDisabled
        }),
        onClick: this.handleToLeft
      }), /*#__PURE__*/React.createElement(_RightCircleFill.default, {
        color: leftDisabled ? '#c0c4cc' : '#D82228',
        className: (0, _classnames.default)({
          'is-disable': leftDisabled
        }),
        onClick: this.handleToRight
      })), /*#__PURE__*/React.createElement(Panel, {
        title: titles[1],
        options: value,
        value: rightChecked,
        onChange: function onChange(value) {
          _this3.setState({
            rightChecked: value,
            rightDisabled: value.length === 0
          });
        }
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value:
    /**
     *
     * @param nextProps
     * @param prevState
     */
    function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.dataSource !== undefined && nextProps.dataSource !== prevState.dataSource) {
        /**判断nextProps与之前存的props的值是否有改变**/
        if (prevState._prevProps !== nextProps) {
          var dataSource = removeRepeat(nextProps.dataSource, nextProps.value);
          /**将本次nextProps的值存在state中去**/

          return {
            _prevProps: nextProps,
            dataSource: dataSource
          };
        }
      }

      return null;
    }
  }]);
  return Transfer;
}(React.PureComponent), _class6.defaultProps = {
  titles: ['列表1', '列表2']
}, _class6), ((0, _applyDecoratedDescriptor2.default)(_class5.prototype, "watchValue", [_dec3], Object.getOwnPropertyDescriptor(_class5.prototype, "watchValue"), _class5.prototype)), _class5)) || _class4);
exports.default = Transfer;