import * as React from 'react';
export interface EnableTransitionProps {
    attribute: keyof CSSStyleDeclaration;
    displayNone?: {
        /**当display==none的时候 是否在动画消失的时候将宽度变成0**/
        setWidthZero: boolean;
        /**当display==none的时候 是否在动画消失的时候将高度变成0**/
        setHeightZero: boolean;
    };
    children: (ref: React.LegacyRef<any>) => React.ReactElement;
}
/**
 * 属性从有变成没有之类的动画
 * @param props
 * @constructor
 */
declare function EnableTransition(props: EnableTransitionProps): React.ReactElement;
export default EnableTransition;
