"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _input = _interopRequireDefault(require("../input"));

var _tree = _interopRequireDefault(require("../tree"));

var _TagGroup = _interopRequireDefault(require("../tag/TagGroup"));

var _FormElement = require("../form/FormElement");

var _dec, _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TreeSelect = (_dec = (0, _FormElement.createFormElement)(), _dec(_class = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(TreeSelect, _React$Component);

  var _super = _createSuper(TreeSelect);

  function TreeSelect() {
    var _this;

    (0, _classCallCheck2.default)(this, TreeSelect);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      value: []
    };
    _this.el = /*#__PURE__*/React.createRef();
    return _this;
  }

  (0, _createClass2.default)(TreeSelect, [{
    key: "handleChange",
    value:
    /***
     *
     */
    function handleChange(value) {
      var arr = [];

      var loop = function loop() {
        var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        value.forEach(function (option) {
          if (option.checked) {
            arr.push({
              label: option.label,
              id: option.id
            });
          } else {
            loop(option.children);
          }
        });
      };

      loop(value);
      this.setState({
        value: arr
      });
    }
    /***
     * 节点点击
     */

  }, {
    key: "handleNodeClick",
    value: function handleNodeClick(e, path, params) {
      var _this$props = this.props,
          multiple = _this$props.multiple,
          checkAble = _this$props.checkAble;
      var value = this.state.value;

      if (multiple && !checkAble) {
        if (!value.find(function (item) {
          return item.id === params.id;
        })) {
          value.push({
            label: params.label,
            id: params.id
          });
        } else {
          value = value.filter(function (item) {
            return item.id !== params.id;
          });
        }

        this.setState({
          value: value
        });
      }

      if (!multiple) {
        if (!params.checked) {
          this.setState({
            value: [{
              label: params.label,
              id: params.id
            }]
          });
        } else {
          this.setState({
            value: []
          });
        }
      }
    }
    /**
     *
     * @param value
     * @param e
     */

  }, {
    key: "handleTagGroupChange",
    value: function handleTagGroupChange(value, e) {
      this.setState({
        value: value
      });
      e.preventDefault();
      e.stopPropagation();
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style,
          size = _this$props2.size,
          dataSource = _this$props2.dataSource,
          multiple = _this$props2.multiple,
          prefix = _this$props2.prefix,
          suffix = _this$props2.suffix,
          prepend = _this$props2.prepend,
          append = _this$props2.append,
          status = _this$props2.status,
          checkAble = _this$props2.checkAble;
      var value = this.state.value;
      var classes = (0, _classnames.default)(className, 'rd-tree-select');
      var checkedKeys = value.map(function (item) {
        return item.id;
      });
      return /*#__PURE__*/React.createElement(_dropdown.default, {
        size: size,
        clickPopperHidden: !multiple,
        clickTriggerRevert: true,
        overlay: /*#__PURE__*/React.createElement("div", {
          className: 'rd-tree-select-popover'
        }, /*#__PURE__*/React.createElement(_tree.default, {
          value: dataSource,
          multiple: multiple,
          showClickStatus: true,
          defaultExpandAll: true,
          checkAble: checkAble,
          checkedKeys: checkedKeys,
          onNodeClick: this.handleNodeClick,
          onChange: this.handleChange
        }))
      }, multiple ? /*#__PURE__*/React.createElement(_TagGroup.default, {
        ref: this.el,
        placeholder: '请选择',
        size: size,
        prefix: prefix,
        suffix: suffix,
        prepend: prepend,
        append: append,
        status: status,
        value: value,
        onChange: this.handleTagGroupChange
      }) : /*#__PURE__*/React.createElement(_input.default, {
        ref: this.el,
        placeholder: '请选择',
        value: value.map(function (item) {
          return item.label;
        }).join(''),
        className: classes,
        style: _objectSpread({}, style),
        size: size,
        prefix: prefix,
        suffix: suffix,
        prepend: prepend,
        append: append,
        status: status
      }));
    }
  }]);
  return TreeSelect;
}(React.Component), _class2.defaultProps = {
  dataSource: [],
  multiple: false,
  nodeKey: 'id',
  nodeCheckedAndCheckedAllChildren: true,
  defaultExpandedKeys: [],
  defaultCheckedKeys: []
}, _class2)) || _class) || _class);
exports.default = TreeSelect;