"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _ajax = _interopRequireDefault(require("./ajax"));

var _Cover = _interopRequireDefault(require("./Cover"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _Preview = _interopRequireDefault(require("./Preview"));

var _locale = _interopRequireDefault(require("../locale"));

var _util = require("../../libs/utils/util");

var _class, _class2;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var AjaxUpload = (0, _autoBind.default)(_class = (_class2 = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(AjaxUpload, _React$PureComponent);

  var _super = _createSuper(AjaxUpload);

  /**
   *构造函数
   * @param props
   */
  function AjaxUpload(props) {
    var _this;

    (0, _classCallCheck2.default)(this, AjaxUpload);
    _this = _super.call(this, props);
    _this.fileInput = void 0;
    _this.state = {
      files: [],
      fileList: [],
      value: ''
    };
    _this.form = void 0;
    _this.canUpload = false;
    (0, _warning.default)(Object.prototype.toString.call(props.extraData) === '[object Object]', 'Upload', '期望传入的extraData是一个对象');
    return _this;
  }
  /**
   * 界面更新后
   */


  (0, _createClass2.default)(AjaxUpload, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var control = this.props.control;

      if (control === true && this.canUpload) {
        this.handleSubmit();
      }
    }
    /**
     * 处理包裹children的点击事件
     */

  }, {
    key: "handleClick",
    value: function handleClick(e) {
      this.fileInput.value = '';
      this.fileInput.click();
      e.stopPropagation();
    }
    /**
     *提交数据
     */

  }, {
    key: "handleSubmit",
    value: function handleSubmit() {
      var _this2 = this;

      this.canUpload = false;
      var _this$props = this.props,
          fileName = _this$props.fileName,
          headers = _this$props.headers,
          withCredentials = _this$props.withCredentials,
          extraData = _this$props.extraData,
          url = _this$props.url,
          showOnly = _this$props.showOnly,
          timeout = _this$props.timeout,
          _onProgress = _this$props.onProgress,
          onSuccess = _this$props.onSuccess,
          onError = _this$props.onError;
      var _this$state = this.state,
          fileList = _this$state.fileList,
          files = _this$state.files;

      var _fileList = Array.from(fileList);

      var singleFile = _fileList.length !== 0 ? _fileList[_fileList.length - 1] : _fileList;
      var req = (0, _ajax.default)({
        timeout: timeout,
        headers: headers,
        withCredentials: withCredentials,
        data: _objectSpread(_objectSpread({}, extraData), {}, (0, _defineProperty2.default)({}, fileName, showOnly ? singleFile : Array.from(fileList))),
        url: url,
        onProgress: function onProgress(e) {
          var _files = files.map(function (itemFile) {
            if (Array.from(fileList).find(function (file) {
              return file === itemFile.file;
            })) {
              return _objectSpread(_objectSpread({}, itemFile), {}, {
                percent: e.percent
              });
            } else {
              return itemFile;
            }
          });

          _this2.setState({
            files: _files
          });

          _onProgress && _onProgress(e, Array.from(fileList));
        }
      });
      req.then(function (res) {
        onSuccess && onSuccess(res);

        _this2.setState({
          fileList: []
        });
      }, function (err) {
        onError && onError(err);

        _this2.setState({
          fileList: []
        });
      });
    }
    /**
     * 校验错误格式
     * @param files
     */

  }, {
    key: "validateFile",
    value: function validateFile(files) {
      var _this3 = this;

      var _this$props2 = this.props,
          accept = _this$props2.accept,
          onError = _this$props2.onError,
          acceptIgnoreCase = _this$props2.acceptIgnoreCase,
          type = _this$props2.type;
      var fileList = Array.from(files);
      return new Promise(function (resolve) {
        if (accept.length > 0) {
          var _loop = function _loop(i) {
            var have = accept.find(function (item) {
              var caseName = fileList[i].name;

              if (acceptIgnoreCase) {
                caseName = caseName.toUpperCase();
                item = item.toUpperCase();
              }

              if (item.startsWith('.')) {
                return caseName.endsWith(item);
              } else {
                return caseName.endsWith(".".concat(item));
              }
            });

            if (!have) {
              _this3.canUpload = false;
              resolve(false);
              onError && onError({
                msg: _locale.default.t('rd.upload.notSupportedFile', {
                  file: fileList[i].name
                })
              });
              return "break";
            }
          };

          for (var i = 0; i < fileList.length; i++) {
            var _ret = _loop(i);

            if (_ret === "break") break;
          }

          if (type === 'card') {
            Promise.all(fileList.map(function (file) {
              return new Promise(function (resolve, reject) {
                var img = new Image();
                img.src = URL.createObjectURL(file);
                img.onerror = reject;
                img.onload = resolve;
              });
            })).then(function () {
              resolve(true);
            }).catch(function () {
              resolve(false);
              _this3.canUpload = false;
              onError && onError({
                msg: _locale.default.t('rd.upload.notValidImage')
              });
            });
          } else {
            resolve(true);
          }
        } else {
          resolve(true);
        }
      });
    }
    /**
     * 选中文件后的处理
     * @param e
     */

  }, {
    key: "handleFileChange",
    value: function () {
      var _handleFileChange = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(e) {
        var _this$props3, onBeforeSubmit, showOnly, files, preFiles, nFiles, _files, fileList;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(e.target.files && e.target.files.length === 0)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _this$props3 = this.props, onBeforeSubmit = _this$props3.onBeforeSubmit, showOnly = _this$props3.showOnly;
                files = e.target.files;
                _context.next = 6;
                return this.validateFile(files);

              case 6:
                if (_context.sent) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return");

              case 8:
                preFiles = this.state.files;
                this.canUpload = true;
                nFiles = Array.from(files).map(function (file) {
                  return {
                    file: file,
                    percent: 0,
                    key: (0, _util.UUID)()
                  };
                });
                _files = showOnly ? nFiles : [].concat((0, _toConsumableArray2.default)(preFiles), (0, _toConsumableArray2.default)(nFiles));
                fileList = this.state.fileList;
                this.setState({
                  fileList: [].concat((0, _toConsumableArray2.default)(fileList), (0, _toConsumableArray2.default)(Array.from(files))),
                  files: _files
                });
                onBeforeSubmit && onBeforeSubmit(files);

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function handleFileChange(_x) {
        return _handleFileChange.apply(this, arguments);
      }

      return handleFileChange;
    }()
    /**
     * 拖拽选中文件后的回调
     * @param files
     */

  }, {
    key: "handleFile",
    value: function () {
      var _handleFile = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(files) {
        var _this$props4, onBeforeSubmit, showOnly, preFiles, nFiles, _files, fileList;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$props4 = this.props, onBeforeSubmit = _this$props4.onBeforeSubmit, showOnly = _this$props4.showOnly;
                _context2.next = 3;
                return this.validateFile(files);

              case 3:
                if (_context2.sent) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return");

              case 5:
                preFiles = this.state.files;
                this.canUpload = true;
                nFiles = Array.from(files).map(function (file) {
                  return {
                    file: file,
                    percent: 0,
                    key: (0, _util.UUID)()
                  };
                });
                _files = showOnly ? nFiles : [].concat((0, _toConsumableArray2.default)(preFiles), (0, _toConsumableArray2.default)(nFiles));
                fileList = this.state.fileList;
                this.setState({
                  fileList: [].concat((0, _toConsumableArray2.default)(fileList), (0, _toConsumableArray2.default)(Array.from(files))),
                  files: _files
                });
                onBeforeSubmit && onBeforeSubmit(files);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function handleFile(_x2) {
        return _handleFile.apply(this, arguments);
      }

      return handleFile;
    }()
    /**
     * 获取layout
     */

  }, {
    key: "getLayout",
    value: function getLayout() {
      var _this$props5 = this.props,
          layout = _this$props5.layout,
          accept = _this$props5.accept,
          hint = _this$props5.hint;

      var _hint = accept.length !== 0 ? _locale.default.t('rd.upload.supportForExtensions', {
        ext: accept.join(' ')
      }) : '',
          preview = true;

      if (layout && !layout.includes('hint')) {
        _hint = '';
      }

      if (hint !== undefined) {
        _hint = hint;
      }

      if (layout && !layout.includes('preview')) {
        preview = false;
      }

      return {
        base: true,
        hint: _hint,
        preview: preview
      };
    }
    /**
     * 提取公共部分
     * @param renderPreview
     * @param hint
     * @param type
     * @param children
     * @param multiple
     * @param fileName
     * @param className
     * @param style
     */

  }, {
    key: "uploadButton",
    value: function uploadButton(renderPreview, hint, type, children, multiple, fileName, className, style, customCard) {
      var _this4 = this;

      return /*#__PURE__*/React.createElement("div", {
        className: (0, _classnames.default)('rd-upload__label', className),
        style: style
      }, /*#__PURE__*/React.createElement(_Cover.default, {
        type: type,
        hint: hint,
        customCard: customCard,
        onClick: this.handleClick,
        onFile: this.handleFile
      }, children), /*#__PURE__*/React.createElement("input", {
        type: "file",
        name: fileName,
        multiple: multiple,
        onChange: this.handleFileChange,
        className: "rd-upload__input",
        ref: function ref(_ref) {
          return _this4.fileInput = _ref;
        }
      }), type !== 'card' && /*#__PURE__*/React.createElement("div", {
        className: "rd-upload__preview"
      }, renderPreview));
    }
    /**
     * 渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props6 = this.props,
          children = _this$props6.children,
          style = _this$props6.style,
          fileName = _this$props6.fileName,
          type = _this$props6.type,
          previewData = _this$props6.previewData,
          multiple = _this$props6.multiple,
          customCard = _this$props6.customCard,
          onDelete = _this$props6.onDelete,
          _onReloaded = _this$props6.onReloaded,
          onError = _this$props6.onError,
          _maxWidth = _this$props6._maxWidth;
      var files = this.state.files;
      var classes = (0, _classnames.default)('rd-upload__ajax');

      var _this$getLayout = this.getLayout(),
          hint = _this$getLayout.hint,
          preview = _this$getLayout.preview;

      var renderPreview;

      if (preview) {
        var previewList = previewData ? previewData.map(function (item) {
          return _objectSpread(_objectSpread({}, item), {}, {
            key: (0, _util.UUID)()
          });
        }) : files.map(function (itemFile) {
          return {
            url: URL.createObjectURL(itemFile.file),
            name: itemFile.file.name,
            percent: itemFile.percent,
            key: itemFile.key
          };
        });
        renderPreview = previewList.map(function (file, index) {
          return /*#__PURE__*/React.createElement(_Preview.default, {
            key: index,
            type: type,
            maxWidth: _maxWidth,
            onDelete: /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3() {
              var prevent;
              return _regenerator.default.wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      if (!onDelete) {
                        _context3.next = 4;
                        break;
                      }

                      _context3.next = 3;
                      return onDelete({
                        name: file.name,
                        url: file.url
                      }, index);

                    case 3:
                      prevent = _context3.sent;

                    case 4:
                      if (prevent !== false) {
                        /**前端预览只需要删除即可**/
                        if (!previewData) {
                          files.splice(index, 1);

                          _this5.setState({
                            files: files
                          });
                        }
                      }

                    case 5:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3);
            })),
            onProgress: function onProgress(e, fileList) {
              var _files = files.map(function (itemFile, it) {
                if (index === it) {
                  return {
                    key: itemFile.key,
                    file: fileList[0],
                    percent: e.percent
                  };
                } else {
                  return itemFile;
                }
              });

              _this5.setState({
                files: _files
              });
            },
            onReloaded: function onReloaded(res) {
              _onReloaded && _onReloaded(res, index);
            },
            onError: onError && onError,
            name: file.name,
            url: file.url,
            percent: file.percent
          });
        });
      }

      return /*#__PURE__*/React.createElement("div", {
        className: classes,
        style: _objectSpread({}, style),
        ref: function ref(_ref3) {
          return _this5.form = _ref3;
        }
      }, type === 'card' ? /*#__PURE__*/React.createElement("div", {
        className: "rd-upload__preview",
        style: {
          display: 'inline-block'
        }
      }, renderPreview, this.uploadButton(renderPreview, hint, type, children, multiple, fileName, 'card-item', {
        padding: 0
      }, customCard)) : this.uploadButton(renderPreview, hint, type, children, multiple, fileName));
    }
  }]);
  return AjaxUpload;
}(React.PureComponent), _class2.defaultProps = {
  fileName: 'file',
  extraData: {},
  headers: {},
  layout: 'base,hint,preview',
  acceptIgnoreCase: true,
  type: 'list',
  accept: [],
  previewData: false,
  withCredentials: false,
  showOnly: true
}, _class2)) || _class;

exports.default = AjaxUpload;