"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _autoBind = _interopRequireDefault(require("../../libs/autoBind"));

var _ref = require("../../libs/ref");

var _createFormElement = require("../../libs/createFormElement");

var _appendPrepend = require("../../libs/appendPrepend");

var _omit = _interopRequireDefault(require("../../libs/omit"));

var _event = _interopRequireDefault(require("../../libs/event"));

var _warning = _interopRequireDefault(require("../../libs/warning"));

var _loop = _interopRequireDefault(require("../../libs/loop"));

var _throttle = _interopRequireDefault(require("../../libs/throttle"));

var _debounce = _interopRequireDefault(require("../../libs/debounce"));

var _domresize = _interopRequireDefault(require("../../libs/domresize"));

var _Portal = _interopRequireDefault(require("../portal/Portal"));

var _renderToString = require("../../libs/utils/renderToString");

var validator = _interopRequireWildcard(require("../../libs/utils/validator"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = {
  decorators: {
    autoBind: _autoBind.default,
    throttle: _throttle.default,
    debounce: _debounce.default,
    forwardRef: _ref.forwardRef,
    createFormElement: _createFormElement.createFormElement,
    loop: _loop.default,
    appendPrepend: _appendPrepend.appendPrepend
  },
  EventTarget: _event.default,
  omit: _omit.default,
  warning: _warning.default,
  validator: validator,
  JSXToText: _renderToString.JSXToText,
  Portal: _Portal.default,
  domresize: _domresize.default
};
exports.default = _default;